<?php
defined('BASEPATH') OR exit('No direct script access allowed');
class Home extends CI_Controller {
	public function __construct() {
		parent::__construct();
		$this->load->database(); // Load the database
		$this->load->helper(array('security')); // Load necessary helpers
	}
	public function index()
	{
		// debug(hashed('mypasswordis@10031989'),true);
		$this->load->helper('text');
		$config['page'] = 'home';
		$this->load->view('frontend/common/header',$config);
		$this->load->view('frontend/home');
		$this->load->view('frontend/common/footer');
	}
	public function processSubscriberEmail()
	{
		// Get the posted email
		$email = $this->input->post('email', TRUE); // TRUE to filter XSS
		// Validate email format
		if (!filter_var($email, FILTER_VALIDATE_EMAIL)) {
			echo json_encode(['status' => 'error', 'message' => 'Invalid email format.']);
			return;
		}
		// Extract domain from the email
		list($user, $domain) = explode('@', $email);
		// Check if the domain has a valid MX record (Domain-level validation)
		if (!checkdnsrr($domain, 'MX')) {
			echo json_encode(['status' => 'error', 'message' => 'Invalid email domain.']);
			return;
		}
		// Get the user's IP address
		$ip_address = $this->input->ip_address();
		// Check if the IP address is already associated with a subscription
		$this->db->where('ip', $ip_address);
		$query = $this->db->get('newsletters');
		if ($query->num_rows() > 0) {
			echo json_encode(['status' => 'error', 'message' => 'You have already subscribed!']);
			return;
		}
		// Check if the email already exists in the database (Prevent duplicate entries)
		$this->db->where('email', $email);
		$query = $this->db->get('newsletters');
		if ($query->num_rows() > 0) {
			echo json_encode(['status' => 'error', 'message' => 'You are already subscribed!']);
			return;
		}
		// Prepare the data to be inserted
		$data = [
			'email' => $email,
			'status' => 1, // 1 for active subscriber
			'ip' => $ip_address, // Get IP address of the user
			'added' => date('Y-m-d H:i:s') // Current timestamp
		];
		// Insert the email into the database
		$this->db->insert('newsletters', $data);
		// Send success response
		echo json_encode(['status' => 'success', 'message' => 'Subscription successful!']);
	}
	public function getContent()
	{
	  if ($this->input->server('REQUEST_METHOD') === 'POST') {
			$cid = hashed($this->input->post('currentCid'),'d') ?? null;
			// echo $cid;
	    echo $this->crud->getDataSingle('contents', $cid, 'cid', null)->content;
	  } else {
	    echo 'Unable to load the content!';
	  }
	}
	public function updateContent()
	{
	  if ($this->input->server('REQUEST_METHOD') === 'POST') {
	    	$cid = hashed($this->input->post('cid'),'d') ?? null;
				$content = $this->input->post('content') ?? null;
				$ru = hashed($this->input->post('ru'),'d') ?? null;
				if ($this->crud->update('contents', 'cid', $cid, ['content' => $content])) {
					$this->session->set_flashdata('type', 'success');
			    $this->session->set_flashdata('title', 'Content Updated!');
			    $this->session->set_flashdata('msg', 'The content has been updated.');
				} else {
					$this->session->set_flashdata('type', 'error');
			    $this->session->set_flashdata('title', 'Error Occured!');
			    $this->session->set_flashdata('msg', 'Unable to update the cntent!');
				}
	  } else {
	    $this->session->set_flashdata('type', 'error');
	    $this->session->set_flashdata('title', 'Error');
	    $this->session->set_flashdata('msg', 'No direct script access allowed.');
	  }
		return redirect($ru);
	}
}
