<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Login extends CI_Controller{
  public function __construct()
  {
    parent::__construct();
    if ($this->session->userdata('su')) {
      $this->session->set_flashdata('type', 'warning');
      $this->session->set_flashdata('title', 'Already Logged In!');
      $this->session->set_flashdata('msg', 'You are already logged in!');
      return redirect(base_url('superadmin.html'));
    }
  }
  public function index()
  {
    $this->load->view('su/login');
  }
  public function authenticate()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      if (empty($this->input->post('username'))) {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Username Field Empty!');
        $this->session->set_flashdata('msg', 'Please enter the username!');
        return redirect(base_url('login.html'));
      }else {
        $username = cleanVal($this->input->post('username'));
      }
      if (empty($this->input->post('password'))) {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Password Field Empty!');
        $this->session->set_flashdata('msg', 'Please enter the password!');
        return redirect(base_url('login.html'));
      }else {
        $password_val = cleanVal($this->input->post('password'));
        $password = hashed($password_val);
      }
      if ($this->crud->checkSU($username,$password) > 0) {
        $user = $this->crud->getDataSingle('su', $username, 'username', null);
        $this->session->set_userdata('role',$user->role);
        $this->session->set_userdata('su',hashed($username));
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Authentication Complete!');
        $this->session->set_flashdata('msg', 'Signed in successfully.');
        return redirect(base_url('superadmin.html'));
      }else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Authentication Failed!');
        $this->session->set_flashdata('msg', 'Please enter the correct login credentials!');
        return redirect(base_url('login.html'));
      }
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('login.html'));
    }
  }
}
?>
