<?php defined('BASEPATH') OR exit('No direct script access allowed');
class Superadmin extends CI_Controller{
  public function __construct()
  {
    parent::__construct();
    $this->load->helper('text');
    if (!$this->session->userdata('su')) {
      $this->session->set_flashdata('type', 'warning');
      $this->session->set_flashdata('title', 'Login To Access!');
      $this->session->set_flashdata('msg', 'Please login to access your account!');
      return redirect(base_url('login.html'));
    }
    $this->su = $this->crud->getDataSingle('su', hashed($this->session->userdata('su'),'d'), 'username', null);
  }
  // public function ()
  // {
  //
  // }
  public function index()
  {
    $data['seoTitle'] = 'Dashboard';
    $this->load->view('secure/inc/header',$data);
    $this->load->view('secure/dashboard');
    $this->load->view('secure/inc/footer');
  }
  public function blog()
  {
    $data['seoTitle'] = 'Blog';
    $this->load->view('secure/inc/header',$data);
    $this->load->view('secure/blog');
    $this->load->view('secure/inc/footer');
  }
  public function saveBlogPost()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      $data['title'] = $this->input->post('title') ?? null;
      $data['description'] = $_POST['description'] ?? null;
      $data['link'] = $this->input->post('link') ?? null;
      $data['created'] = date('Y-m-d H:i:s');
      // File upload configuration
      $config['upload_path']   = './upload/blog/';
      $config['allowed_types'] = 'gif|jpg|jpeg|png';
      $config['max_size']      = 10240; // 10MB in kilobytes
      $config['file_ext_tolower'] = TRUE;
      $config['encrypt_name']  = TRUE;
      $this->load->library('upload', $config);
      // Check if a file is selected
      if (isset($_FILES['photos']) && !empty($_FILES['photos']['name'])) {
        if (!$this->upload->do_upload('photos')) {
          // Upload failed, set flash data and redirect
          $this->session->set_flashdata('type', 'error');
          $this->session->set_flashdata('title', 'Upload Error');
          $this->session->set_flashdata('msg', $this->upload->display_errors());
          return redirect(base_url('superadmin/blog.html'));
        } else {
          // Upload success, get the data
          $uploadData = $this->upload->data();
          $data['photos'] = 'upload/blog/' . $uploadData['file_name'];
        }
      }
      // Save the testimonial data to the database
      if ($this->crud->save('blog', $data, false)) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Post Saved!');
        $this->session->set_flashdata('msg', 'The blog post details have been saved successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occurred!');
        $this->session->set_flashdata('msg', 'Unable to save the details!');
      }
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
    }
    return redirect(base_url('superadmin/blog.html'));
  }
  public function editPost($id=null)
  {
    if (!empty($id)) {
      $data['post'] = $this->crud->getDataSingle('blog', $id, 'id', null);
      $data['seoTitle'] = 'Edit Post';
      $this->load->view('secure/inc/header',$data);
      $this->load->view('secure/blog-edit');
      $this->load->view('secure/inc/footer');
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url());
    }
  }
  public function updateBlogPost()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      $id = $this->input->post('id');
      $data['title'] = $this->input->post('title');
      $data['description'] = $_POST['description'];
      $data['link'] = $this->input->post('link');
      if (isset($_FILES['photos']) && $_FILES['photos']['error'] != UPLOAD_ERR_NO_FILE) {
        // File upload configuration
        $config['upload_path']   = './upload/blog/';
        $config['allowed_types'] = 'gif|jpg|jpeg|png';
        $config['max_size']      = 10240; // 10MB in kilobytes
        $config['file_ext_tolower'] = TRUE;
        $config['encrypt_name']  = TRUE;
        $this->load->library('upload', $config);
        // Check if a file is selected
        if (isset($_FILES['photos']) && !empty($_FILES['photos']['name'])) {
          if (!$this->upload->do_upload('photos')) {
            // Upload failed, set flash data and redirect
            $this->session->set_flashdata('type', 'error');
            $this->session->set_flashdata('title', 'Upload Error');
            $this->session->set_flashdata('msg', $this->upload->display_errors());
            return redirect(base_url('superadmin/editPost/'.$id.'.html'));
          } else {
            // Upload success, get the data
            $uploadData = $this->upload->data();
            $data['photos'] = 'upload/blog/' . $uploadData['file_name'];
          }
        }
      }
      if ($this->crud->update('blog', 'id', $id, $data)) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Post Updated!');
        $this->session->set_flashdata('msg', 'The blog post details have been updated successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occurred!');
        $this->session->set_flashdata('msg', 'Unable to save the details!');
      }
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
    }
    return redirect(base_url('superadmin/blog.html'));
  }
  public function deletePost($id = null)
  {
    if (!empty($id) && $this->crud->getCount('blog', 'id', $id) > 0) {
      $filePath = $this->crud->getDataSingle('blog', $id, 'id', null)->photos;
      if ($this->crud->delete('blog', 'id', $id)) {
        @$this->crud->delete_file($filePath);
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Deleted Successfully!');
        $this->session->set_flashdata('msg', 'The blog post has been deleted successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to process your request!');
      }
      return redirect(base_url('superadmin/blog.html'));
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('superadmin/blog.html'));
    }
  }
  public function setting($settingName = null)
  {
    if (!empty($settingName)) {
      $settingName = cleanVal($settingName);
      if ($this->crud->getCount('settings', 'name', $settingName) > 0) {
        $config['setting'] = $this->crud->getDataSingle('settings', $settingName, 'name');
        $config['seoTitle'] = 'Update '.$config['setting']->text.' | Setting | Admin';
        $this->load->view('secure/inc/header', $config);
        $this->load->view('secure/setting-single');
        $this->load->view('secure/inc/footer');
      } else {
        $config['settings'] = $this->crud->getDataAll('settings');
        $config['seoTitle'] = 'Update Setting - Dashboard';
        $this->load->view('secure/inc/header', $config);
        $this->load->view('secure/setting');
        $this->load->view('secure/inc/footer');
      }
    } else {
      $config['settings'] = $this->crud->getDataAll('settings');
      $config['seoTitle'] = 'Update Setting - Dashboard';
      $this->load->view('secure/inc/header', $config);
      $this->load->view('secure/setting');
      $this->load->view('secure/inc/footer');
    }
  }
  public function saveUpdateSetting()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      $sid = hashed(cleanVal($this->input->post('sid')), 'd');
      $value = cleanVal($this->input->post('value'));
      if ($this->crud->update('settings', 'id', $sid, array('value'=>$value))) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Setting Updated');
        $this->session->set_flashdata('msg', 'Setting has been updated successfully!');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error');
        $this->session->set_flashdata('msg', 'Unable to update the setting due to some technical issue!');
      }
      return redirect(base_url('superadmin/setting.html'));
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('superadmin.html'));
    }
  }
  public function uploadLogo()
  {
    if ($this->input->server('REQUEST_METHOD') == 'POST') {
      if ($_FILES["site_logo"]["name"] != '') {
        $id = cleanVal(hashed($this->input->post('sid'), 'd'));
        $test = explode('.', $_FILES["site_logo"]["name"]);
        $ext = end($test);
        $name = 'infinity-prop-solutions-logo-'.hashed(rand(1,99999999)).$ext;
        $location = 'upload/logo/' . $name;
        // $uploadedLocation = base_url('upload/logo/' . $name);
        if (
          move_uploaded_file($_FILES["site_logo"]["tmp_name"], $location) &&
          $this->crud->update('settings', 'id', $id, array('value'=>$location))
        ) {
          $this->session->set_flashdata('type', 'success');
          $this->session->set_flashdata('title', 'Media Uploaded');
          $this->session->set_flashdata('msg', 'Setting has been updated successfully!');
        } else {
          $this->session->set_flashdata('type', 'error');
          $this->session->set_flashdata('title', 'Error');
          $this->session->set_flashdata('msg', 'Unable to upload the media due to some technical issue!');
        }
        return redirect(base_url('superadmin/setting.html'));
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error');
        $this->session->set_flashdata('msg', 'Please select media file!');
        return redirect(base_url('superadmin.html'));
      }
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('superadmin.html'));
    }
  }
  public function account()
  {
    $config['seoTitle'] = 'Account | Admin | Dashboard';
    $this->load->view('secure/inc/header', $config);
    $this->load->view('secure/account');
    $this->load->view('secure/inc/footer');
  }
  public function updateAccount()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      $aid = hashed(cleanVal($this->input->post('aid')), 'd');
      $account_data_array = array(
        'fname' => $this->input->post('fname'),
        'lname' => $this->input->post('lname'),
        // 'username' => hashed($this->input->post('username')),
        'password' => hashed($this->input->post('password')),
        'email' => $this->input->post('email'),
        'token' => hashed(sha1(rand()))
      );
      // debug($account_data_array, true);
      if ($this->crud->update('su', 'id', $aid, $account_data_array)) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Account Updated');
        $this->session->set_flashdata('msg', 'Account has been updated successfully!');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error');
        $this->session->set_flashdata('msg', 'Unable to update the account due to some technical issue!');
      }
      return redirect(base_url('superadmin/account.html'));
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('superadmin.html'));
    }
  }
  public function upload_image_summernote($folderPath = null)
  {
    if ($_FILES['file']['name']) {
      if (!$_FILES['file']['error']) {
        $name = hashed(rand(100, 20000));
        $ext = strtolower(pathinfo($_FILES['file']['name'], PATHINFO_EXTENSION));
        // $ext = explode('.', $_FILES['file']['name']);
        $filename = 'accel-'.$name . '.' . $ext;
        if (empty($folderPath)) {
          $destination = 'upload/misc/' . $filename; //change this directory
        } else {
          if (!is_dir('upload/'.$folderPath)) {
            //Directory does not exist, so lets create it.
            mkdir('upload/'.$folderPath, 0755);
          }
          $destination = 'upload/'.$folderPath.'/' . $filename; //change this directory
        }
        $location = $_FILES["file"]["tmp_name"];
        move_uploaded_file($location, $destination);
        if (empty($folderPath)) {
          echo base_url('upload/misc/'.$filename);//change this URL
        } else {
          echo base_url('upload/'.$folderPath.'/'.$filename);//change this URL
        }
      } else {
        echo  $message = 'Ooops!  Your upload triggered the following error:  '.$_FILES['file']['error'];
      }
    }
  }
  public function manageFeatures($list = null)
  {
    $config['seoTitle'] = 'Manage Features';
    $this->load->view('secure/inc/header', $config);
    $this->load->view('secure/manage-features');
    $this->load->view('secure/inc/footer');
  }
  public function saveFeatures()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      $data['title'] = cleanVal($this->input->post('feature'));
      if ($this->crud->save('features', $data, null)) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Saved Successfully!');
        $this->session->set_flashdata('msg', 'The feature has been saved successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to process your request!');
      }
      return redirect(base_url('superadmin/manageFeatures.html'));
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('superadmin/manageFeatures.html'));
    }
  }
  public function updateFeatures()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      $id = hashed($this->input->post('id'),'d');
      $data['title'] = cleanVal($this->input->post('feature'));
      if ($this->crud->update('features', 'id', $id, $data)) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Updated Successfully!');
        $this->session->set_flashdata('msg', 'The feature has been updated successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to process your request!');
      }
      return redirect(base_url('superadmin/manageFeatures.html'));
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('superadmin/manageFeatures.html'));
    }
  }
  public function deleteFeatures($id = null)
  {
    if (!empty($id) && $this->crud->getCount('features', 'id', hashed($id,'d')) > 0) {
      $id = hashed($id,'d');
      if ($this->crud->delete('features', 'id', $id)) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Deleted Successfully!');
        $this->session->set_flashdata('msg', 'The feature has been deleted successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to process your request!');
      }
      return redirect(base_url('superadmin/manageFeatures.html'));
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('superadmin/manageFeatures.html'));
    }
  }
  public function managePlacesNearby($list = null)
  {
    $config['seoTitle'] = 'Manage Places Nearby';
    $this->load->view('secure/inc/header', $config);
    $this->load->view('secure/manage-places-nearby');
    $this->load->view('secure/inc/footer');
  }
  public function savePlacesNearby()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      $data['title'] = cleanVal($this->input->post('nearby_place'));
      if ($this->crud->save('places_nearby', $data, null)) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Saved Successfully!');
        $this->session->set_flashdata('msg', 'The nearby place has been saved successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to process your request!');
      }
      return redirect(base_url('superadmin/managePlacesNearby.html'));
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('superadmin/managePlacesNearby.html'));
    }
  }
  public function updatePlacesNearby()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      $id = hashed($this->input->post('id'),'d');
      $data['title'] = cleanVal($this->input->post('nearby_place'));
      if ($this->crud->update('places_nearby', 'id', $id, $data)) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Updated Successfully!');
        $this->session->set_flashdata('msg', 'The nearby place has been updated successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to process your request!');
      }
      return redirect(base_url('superadmin/managePlacesNearby.html'));
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('superadmin/managePlacesNearby.html'));
    }
  }
  public function deletePlacesNearby($id = null)
  {
    if (!empty($id) && $this->crud->getCount('places_nearby', 'id', hashed($id,'d')) > 0) {
      $id = hashed($id,'d');
      if ($this->crud->delete('features', 'id', $id)) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Deleted Successfully!');
        $this->session->set_flashdata('msg', 'The nearby place has been deleted successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to process your request!');
      }
      return redirect(base_url('superadmin/managePlacesNearby.html'));
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('superadmin/managePlacesNearby.html'));
    }
  }
  public function managePropertyType($list = null)
  {
    $config['seoTitle'] = 'Manage Property Type';
    $this->load->view('secure/inc/header', $config);
    $this->load->view('secure/manage-property-type');
    $this->load->view('secure/inc/footer');
  }
  public function savePropertyType()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      $data['title'] = cleanVal($this->input->post('property_type'));
      if ($this->crud->save('property_list', $data, null)) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Saved Successfully!');
        $this->session->set_flashdata('msg', 'The property type has been saved successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to process your request!');
      }
      return redirect(base_url('superadmin/managePropertyType.html'));
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('superadmin/managePropertyType.html'));
    }
  }
  public function updatePropertyType()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      $id = hashed($this->input->post('id'),'d');
      $data['title'] = cleanVal($this->input->post('property_type'));
      if ($this->crud->update('property_list', 'id', $id, $data)) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Updated Successfully!');
        $this->session->set_flashdata('msg', 'The property type has been updated successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to process your request!');
      }
      return redirect(base_url('superadmin/managePropertyType.html'));
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('superadmin/managePropertyType.html'));
    }
  }
  public function deletePropertyType($id = null)
  {
    if (!empty($id) && $this->crud->getCount('property_list', 'id', hashed($id,'d')) > 0) {
      $id = hashed($id,'d');
      if ($this->crud->delete('property_list', 'id', $id)) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Deleted Successfully!');
        $this->session->set_flashdata('msg', 'The property type has been deleted successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to process your request!');
      }
      return redirect(base_url('superadmin/managePropertyType.html'));
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('superadmin/managePropertyType.html'));
    }
  }
  public function manageLocations($list = null)
  {
    $config['seoTitle'] = 'Manage Locations';
    $this->load->view('secure/inc/header', $config);
    $this->load->view('secure/manage-location');
    $this->load->view('secure/inc/footer');
  }
  public function saveLocations()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      $data['title'] = cleanVal($this->input->post('location'));
      $data['uri'] = cu(strtolower($data['title']));
      if ($_FILES["img"]["error"] == 0) {
        $test = explode('.', $_FILES["img"]["name"]);
        $ext = end($test);
        $folder = 'location';
        if (!file_exists('upload/'.$folder)) {
          mkdir('upload/'.$folder, 0777, true);
        }
        $name = $folder.'_'.$data['uri'].'.'.$ext;
        $location = 'upload/'.$folder.'/'.$name;
        if (move_uploaded_file($_FILES["img"]["tmp_name"], $location)) {
          $data['img'] = $location;
        } else {
          $data['img'] = null;
        }
      }
      if ($this->crud->save('locations', $data, null)) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Saved Successfully!');
        $this->session->set_flashdata('msg', 'The location has been saved successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to process your request!');
      }
      return redirect(base_url('superadmin/manageLocations.html'));
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('superadmin/manageLocations.html'));
    }
  }
  public function updateLocations()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      $id = hashed($this->input->post('id'),'d');
      $data['title'] = cleanVal($this->input->post('location'));
      $data['uri'] = cu(strtolower($data['title']));
      if ($_FILES["img"]["error"] == 0) {
        $test = explode('.', $_FILES["img"]["name"]);
        $ext = end($test);
        $folder = 'location';
        if (!file_exists('upload/'.$folder)) {
          mkdir('upload/'.$folder, 0777, true);
        }
        $name = $folder.'_'.$data['uri'].'.'.$ext;
        $location = 'upload/'.$folder.'/'.$name;
        if (move_uploaded_file($_FILES["img"]["tmp_name"], $location)) {
          $data['img'] = $location;
        } else {
          $data['img'] = null;
        }
      }
      if ($this->crud->update('locations', 'id', $id, $data)) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Updated Successfully!');
        $this->session->set_flashdata('msg', 'The location has been updated successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to process your request!');
      }
      return redirect(base_url('superadmin/manageLocations.html'));
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('superadmin/manageLocations.html'));
    }
  }
  public function deleteLocations($id = null)
  {
    if (!empty($id) && $this->crud->getCount('locations', 'id', hashed($id,'d')) > 0) {
      $id = hashed($id,'d');
      if ($this->crud->delete('locations', 'id', $id)) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Deleted Successfully!');
        $this->session->set_flashdata('msg', 'The location has been deleted successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to process your request!');
      }
      return redirect(base_url('superadmin/manageLocations.html'));
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('superadmin/manageLocations.html'));
    }
  }
  public function manageProperty($option1 = null, $option2 = null)
  {
    // debug($option1,true);
    if ($option1 == 'uploadPropertyAttachments') {
      $config['pid'] = cleanVal($option2);
      $config['property'] = $this->crud->getDataSingle('property', hashed($config['pid'],'d'), 'id', null);
      $config['seoTitle'] = 'Upload Property Attachments';
      $this->load->view('secure/inc/header', $config);
      $this->load->view('secure/upload-property-attachments');
      $this->load->view('secure/inc/footer');
    }else if($option1 == 'floorPlans'){
      $config['pid'] = cleanVal($option2);
      $config['property'] = $this->crud->getDataSingle('property', hashed($config['pid'],'d'), 'id', null);
      $config['seoTitle'] = 'Upload Property Attachments';
      $this->load->view('secure/inc/header', $config);
      $this->load->view('secure/floor-plans');
      $this->load->view('secure/inc/footer');
    } else {
      $config['seoTitle'] = 'Manage Residential Properties';
      $config['prop'] = $this->crud->getPropertyList(null, 'DESC', null);
      $this->load->view('secure/inc/header', $config);
      $this->load->view('secure/manage-property');
      $this->load->view('secure/inc/footer');
    }
  }
  public function managePropertyCommercial($option1 = null, $option2 = null)
  {
    // debug($option1,true);
    if ($option1 == 'uploadPropertyAttachments') {
      $config['pid'] = cleanVal($option2);
      $config['property'] = $this->crud->getDataSingle('property', hashed($config['pid'],'d'), 'id', null);
      $config['seoTitle'] = 'Upload Property Attachments';
      $this->load->view('secure/inc/header', $config);
      $this->load->view('secure/upload-property-attachments');
      $this->load->view('secure/inc/footer');
    }else if($option1 == 'floorPlans'){
      $config['pid'] = cleanVal($option2);
      $config['property'] = $this->crud->getDataSingle('property', hashed($config['pid'],'d'), 'id', null);
      $config['seoTitle'] = 'Upload Property Attachments';
      $this->load->view('secure/inc/header', $config);
      $this->load->view('secure/floor-plans');
      $this->load->view('secure/inc/footer');
    } else {
      $config['seoTitle'] = 'Manage Commercial Properties';
      $config['prop'] = $this->crud->getPropertyList('commercial', 'DESC', null);
      $this->load->view('secure/inc/header', $config);
      $this->load->view('secure/manage-property');
      $this->load->view('secure/inc/footer');
    }
  }
  public function addProperty($list = null)
  {
    $config['seoTitle'] = 'Add Property Listing';
    $this->load->view('secure/inc/header', $config);
    $this->load->view('secure/add-property');
    $this->load->view('secure/inc/footer');
  }
  public function saveProperty()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      $data['project_type'] = $this->input->post('project_type') ?? null;
      $data['location'] = $this->input->post('location') ?? null;
      $data['address'] = $this->input->post('address') ?? null;
      $data['address_map'] = $this->input->post('address_map') ?? null;
      $data['featured_properties'] = $this->input->post('featured_properties') ?? null;
      $data['property_type'] = $this->input->post('property_type') ?? null;
      $data['property_status'] = $this->input->post('property_status') ?? null;
      $data['title'] = $this->input->post('title') ?? null;
      $data['uri'] = $this->input->post('uri') ?? null;
      $data['description'] = $_POST['description'];
      $data['property_id'] = $this->input->post('property_id') ?? null;
      $data['price'] = $this->input->post('price') ?? null;
      $data['price_rent'] = $this->input->post('price_rent') ?? null;
      $data['property_size'] = $this->input->post('property_size') ?? null;
      $data['property_size_matrix'] = $this->input->post('property_size_matrix') ?? null;
      // $data['year_built'] = $this->input->post('year_built') ?? null;
      $data['bedrooms'] = $this->input->post('bedrooms') ?? null;
      $data['bathrooms'] = $this->input->post('bathrooms') ?? null;
      $data['parking'] = $this->input->post('parking') ?? null;
      // $data['garage'] = $this->input->post('garage') ?? null;
      // $data['garage_size'] = $this->input->post('garage_size') ?? null;
      // $data['deposit'] = $this->input->post('deposit') ?? null;
      // $data['last_remodel_year'] = $this->input->post('last_remodel_year') ?? null;
      // $data['pool_size'] = $this->input->post('pool_size') ?? null;
      // $data['additional_rooms'] = $this->input->post('additional_rooms') ?? null;
      if (is_array($this->input->post('amenities')) && !empty($this->input->post('amenities'))) {
        $data['amenities'] = implode(',',$this->input->post('amenities'));
      }
      // if (is_array($this->input->post('equipment')) && !empty($this->input->post('equipment'))) {
      //   $data['equipment'] = implode(',',$this->input->post('equipment'));
      // }
      // if (is_array($this->input->post('places_nearby')) && !empty($this->input->post('places_nearby'))) {
      //   $data['places_nearby'] = implode(',',$this->input->post('places_nearby'));
      // }
      //
      // $data['amenities'] = implode(',',$this->input->post('amenities'));
      // $data['equipment'] = implode(',',$this->input->post('equipment'));
      $data['for_status'] = $this->input->post('for_status') ?? null;
      $data['discount_message'] = $this->input->post('discount_message') ?? null;
      // $data['ready_to_move'] = $this->input->post('ready_to_move') ?? null;
      $data['created'] = date('Y-m-d H:i:s');
      $data['updated'] = date('Y-m-d H:i:s');
      if ($_FILES["cover_photo"]["error"] == 0) {
        $test = explode('.', $_FILES["cover_photo"]["name"]);
        $ext = end($test);
        $folder = 'cover_photo';
        if (!file_exists('upload/'.$folder)) {
          mkdir('upload/'.$folder, 0777, true);
        }
        $randChar = hashed(rand(100, 20000));
        $name = $folder.'_'.$randChar.'.'.$ext;
        $location = 'upload/'.$folder.'/'.$name;
        if (move_uploaded_file($_FILES["cover_photo"]["tmp_name"], $location)) {
          $data['cover_photo'] = $location;
        } else {
          $data['cover_photo'] = null;
        }
      }
      if ($id = $this->crud->save('property', $data, true)) {
        if ($_FILES['photo_gallery']['error'][0] == 0) {
          $photos_array = reArrayFiles($_FILES['photo_gallery']);
          $count_photo = sizeof($photos_array);
          for ($i=0; $i < $count_photo; $i++) {
            $targetDir = 'upload/property_photos/';
            $targetFile = $targetDir.'property_image_'.rand(1, time()).'-'. str_replace(' ', '-', $photos_array[$i]['name']);
            if (move_uploaded_file($photos_array[$i]['tmp_name'], $targetFile)) {
              $gp[] = $targetFile;
            } else {
              $gp[] = null;
            }
          }
          foreach ($gp as $gp) {
            $this->crud->save('gallery', ['pid'=>$id,'src'=>$gp,'type'=>'photo'], null);
          }
        }
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Property Details Saved!');
        $this->session->set_flashdata('msg', 'The property details has been saved successfully.');
        return redirect(base_url('superadmin/manageProperty/uploadPropertyAttachments/'.hashed($id).'.html'));
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to process your request!');
        if ($data['project_type'] === 'residential') {
          return redirect(base_url('superadmin/manageProperty.html'));
        } else {
          return redirect(base_url('superadmin/managePropertyCommercial.html'));
        }
      }
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('superadmin.html'));
    }
  }
  public function editProperty($pid=null)
  {
    if (!empty($pid)) {
      $config['prp'] = $this->crud->getDataSingle('property', hashed($pid,'d'), 'id', null);
      $config['seoTitle'] = 'Edit Properties Details';
      $this->load->view('secure/inc/header', $config);
      $this->load->view('secure/edit-property-details');
      $this->load->view('secure/inc/footer');
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('superadmin.html'));
    }
  }
  public function updateProperty()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      $pid = hashed($this->input->post('pid'),'d');
      $data['project_type'] = $this->input->post('project_type');
      $data['location'] = $this->input->post('location');
      $data['address'] = $this->input->post('address');
      $data['address_map'] = $this->input->post('address_map');
      $data['featured_properties'] = $this->input->post('featured_properties');
      $data['property_type'] = $this->input->post('property_type');
      $data['property_status'] = $this->input->post('property_status');
      $data['title'] = $this->input->post('title');
      $data['uri'] = $this->input->post('uri');
      $data['description'] = $_POST['description'];
      $data['property_id'] = $this->input->post('property_id');
      $data['price'] = $this->input->post('price');
      $data['price_rent'] = $this->input->post('price_rent');
      $data['property_size'] = $this->input->post('property_size');
      $data['property_size_matrix'] = $this->input->post('property_size_matrix');
      // $data['year_built'] = $this->input->post('year_built');
      $data['bedrooms'] = $this->input->post('bedrooms');
      $data['bathrooms'] = $this->input->post('bathrooms');
      $data['parking'] = $this->input->post('parking');
      // $data['garage'] = $this->input->post('garage');
      // $data['garage_size'] = $this->input->post('garage_size');
      // $data['deposit'] = $this->input->post('deposit');
      // $data['last_remodel_year'] = $this->input->post('last_remodel_year');
      // $data['pool_size'] = $this->input->post('pool_size');
      if (is_array($this->input->post('amenities')) && !empty($this->input->post('amenities'))) {
        $data['amenities'] = implode(',',$this->input->post('amenities'));
      }
      // if (is_array($this->input->post('equipment')) && !empty($this->input->post('equipment'))) {
      //   $data['equipment'] = implode(',',$this->input->post('equipment'));
      // }
      // if (is_array($this->input->post('places_nearby')) && !empty($this->input->post('places_nearby'))) {
      //   $data['places_nearby'] = implode(',',$this->input->post('places_nearby'));
      // }
      $data['for_status'] = $this->input->post('for_status');
      // $data['ready_to_move'] = $this->input->post('ready_to_move')
      $data['discount_message'] = $this->input->post('discount_message');
      $data['updated'] = date('Y-m-d H:i:s');
      if ($_FILES["cover_photo"]["error"] == 0) {
        $test = explode('.', $_FILES["cover_photo"]["name"]);
        $ext = end($test);
        $folder = 'cover_photo';
        if (!file_exists('upload/'.$folder)) {
          mkdir('upload/'.$folder, 0777, true);
        }
        $randChar = hashed(rand(100, 20000));
        $name = $folder.'_'.$randChar.'.'.$ext;
        $location = 'upload/'.$folder.'/'.$name;
        if (move_uploaded_file($_FILES["cover_photo"]["tmp_name"], $location)) {
          $data['cover_photo'] = $location;
        }
      }
      if ($this->crud->update('property', 'id', $pid, $data)) {
        if ($_FILES['photo_gallery']['error'][0] == 0) {
          $photos_array = reArrayFiles($_FILES['photo_gallery']);
          $count_photo = sizeof($photos_array);
          for ($i=0; $i < $count_photo; $i++) {
            $targetDir = 'upload/property_photos/';
            $targetFile = $targetDir.'property_image_'.rand(1, time()).'-'. str_replace(' ', '-', $photos_array[$i]['name']);
            if (move_uploaded_file($photos_array[$i]['tmp_name'], $targetFile)) {
              $gp[] = $targetFile;
            }
          }
          foreach ($gp as $gp) {
            $this->crud->save('gallery', ['pid'=>$pid,'src'=>$gp,'type'=>'photo'], null);
          }
        }
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Property Details Updated!');
        $this->session->set_flashdata('msg', 'The property details has been updated successfully.');
        return redirect(base_url('superadmin/editProperty/'.hashed($pid).'.html'));
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to process your request!');
        return redirect(base_url('superadmin/editProperty/'.hashed($pid).'.html'));
      }
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('superadmin.html'));
    }
  }
  public function deletePrpertyGalleryPhoto($prpoertyId=null,$photoId=null)
  {
    if (!empty($prpoertyId) && !empty($photoId)) {
      $prpoertyId = cleanVal($prpoertyId);
      $photoId = hashed(cleanVal($photoId),'d');
      $photo = $this->crud->getDataSingle('gallery',$photoId, 'id', null);
      if ($this->crud->delete('gallery', 'id', $photoId) && $this->crud->delete_file($photo->src)) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Gallery Photo Deleted!');
        $this->session->set_flashdata('msg', 'The gallery photo has been deleted successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to process your request!');
      }
      return redirect(base_url('superadmin/editProperty/'.$prpoertyId.'.html'));
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('superadmin.html'));
    }
  }
  public function deletePrpertyGalleryVideo($prpoertyId=null,$photoId=null)
  {
    if (!empty($prpoertyId) && !empty($photoId)) {
      $prpoertyId = cleanVal($prpoertyId);
      $photoId = hashed(cleanVal($photoId),'d');
      $photo = $this->crud->getDataSingle('gallery',$photoId, 'id', null);
      if ($this->crud->delete('gallery', 'id', $photoId) && $this->crud->delete_file($photo->src)) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Property Video Deleted!');
        $this->session->set_flashdata('msg', 'The property video has been deleted successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to process your request!');
      }
      return redirect(base_url('superadmin/uploadPropertyVideo/'.$prpoertyId.'.html'));
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('superadmin.html'));
    }
  }
  public function deleteProperty($prpoertyId=null)
  {
    if (!empty($prpoertyId))
    {
      $prpoertyId = hashed(cleanVal($prpoertyId),'d');
      $property = $this->crud->getDataSingle('property',$prpoertyId, 'id', null);
      $photos = $this->crud->getDataSingle('gallery',$prpoertyId, 'pid', true);
      $pat = $this->crud->getDataSingle('property_attachments',hashed($prpoertyId), 'pid', true);
      $floor_plan = $this->crud->getDataSingle('floor_plans',hashed($prpoertyId), 'pid', true);
      if ($this->crud->delete('property', 'id', $prpoertyId))
      {
        if (file_exists($property->cover_photo))
        {
          $this->crud->delete_file($property->cover_photo);
        }
        if ($this->crud->getCount('gallery', 'pid', $prpoertyId) > 0)
        {
          foreach ($photos as $photo) {
            $this->crud->delete('gallery', 'id', $photo->id);
            if (file_exists($photo->src))
            {
              $this->crud->delete_file($photo->src);
            }
          }
        }
        if ($this->crud->getCount('property_attachments', 'pid', hashed($prpoertyId)) > 0) {
          foreach ($pat as $pa) {
            $this->crud->delete('property_attachments', 'id', $pa->id);
            if (file_exists($pa->file))
            {
              $this->crud->delete_file($pa->file);
            }
          }
        }
        if ($this->crud->getCount('floor_plans', 'pid', hashed($prpoertyId)) > 0) {
          foreach ($floor_plan as $pl) {
            $this->crud->delete('floor_plans', 'id', $pl->id);
            if (file_exists($pl->file))
            {
              $this->crud->delete_file($pl->file);
            }
          }
        }
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Property Listing Deleted!');
        $this->session->set_flashdata('msg', 'The property listing has been deleted successfully.');
      }
      else
      {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to process your request!');
      }
      if ($property->project_type === 'residential') {
        return redirect(base_url('superadmin/manageProperty.html'));
      } else {
        return redirect(base_url('superadmin/managePropertyCommercial.html'));
      }
    }
    else
    {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('superadmin.html'));
    }
  }
  public function checkAjaxPropertyURI()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      if ($this->crud->getCount('property', 'uri', $this->input->post('uri')) > 0) {
        echo 'found';
      } else {
        echo 'notfound';
      }
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('superadmin.html'));
    }
  }
  public function updatePropertyStatus()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      $pid = hashed($this->input->post('pid'),'d');
      $property_status = $this->input->post('property_status');
      $property = $this->crud->getDataSingle('property',$pid, 'id', null);
      if ($this->crud->update('property', 'id', $pid, ['property_status'=>$property_status])) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Property Status Updated!');
        $this->session->set_flashdata('msg', 'The property status has been updated successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to process your request!');
      }
      if ($property->project_type === 'residential') {
        return redirect(base_url('superadmin/manageProperty.html'));
      } else {
        return redirect(base_url('superadmin/managePropertyCommercial.html'));
      }
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('superadmin.html'));
    }
  }
  public function uploadPropertyAttachments()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      $data['pid'] = $this->input->post('pid');
      $data['title'] = $this->input->post('title');
      if ($_FILES["file"]["error"] == 0) {
        $test = explode('.', $_FILES["file"]["name"]);
        $ext = end($test);
        $folder = 'property_attachment';
        if (!file_exists('upload/'.$folder)) {
          mkdir('upload/'.$folder, 0777, true);
        }
        $randChar = hashed(rand(100, 20000));
        $name = $folder.'_'.$randChar.'.'.$ext;
        $location = 'upload/'.$folder.'/'.$name;
        if (move_uploaded_file($_FILES["file"]["tmp_name"], $location)) {
          $data['file'] = $location;
        } else {
          $data['file'] = null;
        }
      }
      if ($this->crud->save('property_attachments', $data, null)) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Property Attachment Uploaded!');
        $this->session->set_flashdata('msg', 'The property attachment has been uploaded successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to process your request!');
      }
      return redirect(base_url('superadmin/manageProperty/uploadPropertyAttachments/'.$data['pid'].'html'));
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('superadmin.html'));
    }
  }
  public function uploadPropertyFloorPlan()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      $data['pid'] = $this->input->post('pid');
      $data['floor_title'] = $this->input->post('floor_title');
      $data['floor_size'] = $this->input->post('floor_size');
      $data['rooms'] = $this->input->post('rooms');
      $data['baths'] = $this->input->post('baths');
      $data['price'] = $this->input->post('price');
      $data['description'] = $this->input->post('description');
      if ($_FILES["file"]["error"] == 0) {
        $test = explode('.', $_FILES["file"]["name"]);
        $ext = end($test);
        $folder = 'property_floor_plans';
        if (!file_exists('upload/'.$folder)) {
          mkdir('upload/'.$folder, 0777, true);
        }
        $randChar = hashed(rand(100, 20000));
        $name = $folder.'_'.$randChar.'.'.$ext;
        $location = 'upload/'.$folder.'/'.$name;
        if (move_uploaded_file($_FILES["file"]["tmp_name"], $location)) {
          $data['file'] = $location;
        } else {
          $data['file'] = null;
        }
      }
      if ($this->crud->save('floor_plans', $data, null)) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Property Floor Plans Added!');
        $this->session->set_flashdata('msg', 'The property floor plan has been uploaded successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to process your request!');
      }
      return redirect(base_url('superadmin/manageProperty/floorPlans/'.$data['pid'].'html'));
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('superadmin.html'));
    }
  }
  public function deletePA($id=null,$pid=null)
  {
    if (!empty($id) && !empty($pid)) {
      $id = hashed(cleanVal($id),'d');
      $pid = cleanVal($pid);
      $pa = $this->crud->getDataSingle('property_attachments', hashed($id), 'pid', null);
      if ($this->crud->delete('property_attachments', 'id', $id)) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Property Attachment Deleted!');
        $this->session->set_flashdata('msg', 'The property attachment has been deleted successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to process your request!');
      }
      return redirect(base_url('superadmin/manageProperty/uploadPropertyAttachments/'.$pid.'.html'));
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('superadmin.html'));
    }
  }
  public function deleteFP($id=null,$pid=null)
  {
    if (!empty($id) && !empty($pid)) {
      $id = hashed(cleanVal($id),'d');
      $pid = cleanVal($pid);
      $pa = $this->crud->getDataSingle('floor_plans', hashed($id), 'pid', null);
      if ($this->crud->delete(' floor_plans', 'id', $id)) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Property Floor Plan Deleted!');
        $this->session->set_flashdata('msg', 'The floor plan has been deleted successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to process your request!');
      }
      return redirect(base_url('superadmin/manageProperty/floorPlan/'.$pid.'.html'));
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('superadmin.html'));
    }
  }
  public function messages()
  {
    $config['seoTitle'] = 'Manage Messages';
    $this->load->view('secure/inc/header', $config);
    $this->load->view('secure/manage-messages');
    $this->load->view('secure/inc/footer');
  }
  public function fetchSingleMessage()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      $mid = hashed($this->input->post('mid'),'d');
      $type = hashed($this->input->post('type'),'d');
      $message = $this->crud->getDataSingle('records', $mid, 'id', null);
      if ($this->crud->getCount('records', 'id', $mid) > 0) {
        $this->crud->update('records', 'id', $mid, ['status'=>'read']);
        $res = 'fetched';
        if ($type === 'contact') {
          $subject = '<i class="fas fa-envelope"></i> '.$message->subject;
          $body = '
          <table class="table table-striped table-hover">
          <tr>
          <th>Name</th>
          <td>'.ucwords($message->name).'</td>
          </tr>
          <tr>
          <th>Phone</th>
          <td>'.$message->phone.'</td>
          </tr>
          <tr>
          <th>Email</th>
          <td>'.$message->email.'</td>
          </tr>
          <tr>
          <th>Subject</th>
          <td>'.ucfirst($message->subject).'</td>
          </tr>
          <tr>
          <th>Message</th>
          <td>'.$message->message.'</td>
          </tr>
          </table>
          ';
        } elseif ($type === 'expert') {
          $subject = '<i class="fas fa-envelope"></i> Request from '.$message->name;
          $body = '
          <table class="table table-striped table-hover">
          <tr>
          <th>Name</th>
          <td>'.ucwords($message->name).'</td>
          </tr>
          <tr>
          <th>Phone</th>
          <td>'.$message->phone.'</td>
          </tr>
          <tr>
          <th>Email</th>
          <td>'.$message->email.'</td>
          </tr>
          </table>
          ';
        }else {
          $property = $this->crud->getDataSingle('property', hashed($message->pid,'d'), 'id', null);;
          $subject = '<i class="fas fa-envelope"></i> '.'Message from '.ucwords($message->name);
          $body = '
          <table class="table table-striped table-hover">
          <tr>
          <th>Name</th>
          <td>'.ucwords($message->name).'</td>
          </tr>
          <tr>
          <th>Phone</th>
          <td>'.$message->phone.'</td>
          </tr>
          <tr>
          <th>Email</th>
          <td>'.$message->email.'</td>
          </tr>
          <tr>
          <th>Message</th>
          <td>'.$message->message.'</td>
          </tr>
          <tr>
          <th>Property Listing</th>
          <td><a href="'.base_url('property/'.$property->uri.'.html').'" target="_blank">'.ucwords($property->title).'</a></td>
          </tr>
          </table>
          ';
        }
      }else {
        $res = 'error';
        $subject = 'Message Not Found!';
        $body = 'The requested message has not been found!';
      }
      $output = array(
        'status' => $res,
        'subject' => $subject,
        'msg' => $body,
      );
      echo json_encode($output);
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('superadmin.html'));
    }
  }
  public function starMessage($status=null,$mid=null)
  {
    if (!empty($status) && !empty($mid)) {
      if ($this->crud->update('records', 'id', hashed(cleanVal($mid),'d'), ['star'=>cleanVal($status)])) {
        $this->session->set_flashdata('type', 'success');
        if (cleanVal($status) == 'yes') {
          $this->session->set_flashdata('title', 'Message Marked As Important!');
          $this->session->set_flashdata('msg', 'The message has been marked as important successfully.');
        }else {
          $this->session->set_flashdata('title', 'Message Marked As Unimportant!');
          $this->session->set_flashdata('msg', 'The message has been marked as unimportant successfully.');
        }
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to process your request!');
      }
      return redirect(base_url('superadmin/messages.html'));
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url());
    }
  }
  public function deleteMessage($mid=null)
  {
    if (!empty($mid)) {
      $mid = hashed(cleanVal($mid),'d');
      if ($this->crud->delete('records', 'id', $mid)) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Message Deleted!');
        $this->session->set_flashdata('msg', 'The message has been deleted successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to process your request!');
      }
      return redirect(base_url('superadmin/messages.html'));
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('superadmin.html'));
    }
  }
  public function uploadPropertyVideo($id=null)
  {
    $config['prp'] = $this->crud->getDataSingle('property', cleanVal(hashed($id,'d')), 'id', null);
    $config['seoTitle'] = 'Upload Videos';
    $this->load->view('secure/inc/header', $config);
    $this->load->view('secure/upload-videos');
    $this->load->view('secure/inc/footer');
  }
  public function processUploadVideo()
  {
    if (!$_FILES["uploadingfile"]["tmp_name"]) {//No file chosen
      echo "ERROR: Please browse for a file before clicking the upload button.";
      exit();
    } else {
      $extension = pathinfo($_FILES['uploadingfile']['name'], PATHINFO_EXTENSION);
      if ((($_FILES["uploadingfile"]["type"] == "video/mp4")) && $extension == 'mp4') {
        //Directory to put file into
        $folderPath = "upload/property_videos/";
        //File name
        $original_file_name = $_FILES["uploadingfile"]["name"];
        $newFileName = $folderPath.'property-video-'.rand(1, time()).'-'. str_replace(' ', '-', $original_file_name);
        $size_raw = $_FILES["uploadingfile"]["size"];//File size in bytes
        $size_as_mb = number_format(($size_raw / 1048576), 2);//Convert bytes to Megabytes
        if (move_uploaded_file($_FILES["uploadingfile"]["tmp_name"], $newFileName. "")) {
          $this->crud->save('gallery', ['pid'=>hashed($this->input->post('pid'),'d'),'src'=>$newFileName,'type'=>'video'], null);
          echo '<video width="100%" height="340" controls>
          <source src="'.base_url($newFileName).'" type="video/mp4">
          Your browser does not support the video tag.
          </video>';
        }
      } else {
        echo "File is not a MP4";
        exit;
      }
    }
  }
  public function testimonials($id=null)
  {
    $config['seoTitle'] = 'Testimonials';
    $this->load->view('secure/inc/header', $config);
    $this->load->view('secure/testimonials');
    $this->load->view('secure/inc/footer');
  }
  public function addTestimonial($id=null)
  {
    $config['seoTitle'] = 'Add Testimonial';
    $this->load->view('secure/inc/header', $config);
    $this->load->view('secure/addTestimonial');
    $this->load->view('secure/inc/footer');
  }
  public function saveTestmonial()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      $data['name'] = $this->input->post('name') ?? null;
      $data['position'] = $this->input->post('position') ?? null;
      $data['content'] = $this->input->post('content') ?? null;
      $data['rating'] = $this->input->post('rating') ?? null;
      $data['status'] = $this->input->post('status') ?? null;
      $data['added'] = date('Y-m-d H:i:s');
      // File upload configuration
      $config['upload_path']   = './upload/testimonials/';
      $config['allowed_types'] = 'gif|jpg|jpeg|png';
      $config['max_size']      = 10240; // 10MB in kilobytes
      $config['file_ext_tolower'] = TRUE;
      $config['encrypt_name']  = TRUE;
      $this->load->library('upload', $config);
      // Check if a file is selected
      if (isset($_FILES['photos']) && !empty($_FILES['photos']['name'])) {
        if (!$this->upload->do_upload('photos')) {
          // Upload failed, set flash data and redirect
          $this->session->set_flashdata('type', 'error');
          $this->session->set_flashdata('title', 'Upload Error');
          $this->session->set_flashdata('msg', $this->upload->display_errors());
          return redirect(base_url('superadmin/testimonials.html'));
        } else {
          // Upload success, get the data
          $uploadData = $this->upload->data();
          $data['photos'] = 'upload/testimonials/' . $uploadData['file_name'];
        }
      }
      // Save the testimonial data to the database
      if ($this->crud->save('testimonials', $data, false)) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Data Saved!');
        $this->session->set_flashdata('msg', 'The testimonial details have been saved successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occurred!');
        $this->session->set_flashdata('msg', 'Unable to save the details!');
      }
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
    }
    return redirect(base_url('superadmin/testimonials.html'));
  }
  public function deleteTestimonial($id=null)
  {
    if (!empty($id)) {
      if ($this->crud->delete('testimonials', 'id', hashed($id,'d'))) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Data Deleted!');
        $this->session->set_flashdata('msg', 'The testimonial details have been deleted successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occurred!');
        $this->session->set_flashdata('msg', 'Unable to delete the details!');
      }
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
    }
    return redirect(base_url('superadmin/testimonials.html'));
  }
  public function manageFaqs()
  {
    $config['seoTitle'] = 'Manage F.A.Q';
    $this->load->view('secure/inc/header', $config);
    $this->load->view('secure/manage-faqs');
    $this->load->view('secure/inc/footer');
  }
  public function saveFAQ()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      $data['q'] = $this->input->post('q');
      $data['a'] = $this->input->post('a');
      $data['added'] = date('Y-m-d H:i:s');
      if ($this->crud->save('faqs', $data, false)) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'FAQ Saved!');
        $this->session->set_flashdata('msg', 'FAQ has been saved successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to save the FAQ due to error!');
      }
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
    }
    return redirect(base_url('superadmin/manageFaqs.html'));
  }
  public function updateFAQ()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      $id = hashed($this->input->post('id'),'d');
      $data['q'] = $this->input->post('q');
      $data['a'] = $this->input->post('a');
      if ($this->crud->update('faqs', 'id', $id, $data)) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'FAQ Updated!');
        $this->session->set_flashdata('msg', 'FAQ has been updated successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to delete the FAQ due to error!');
      }
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
    }
    return redirect(base_url('superadmin/manageFaqs.html'));
  }
  public function deleteFaq($id=null)
  {
    if (!empty($id)) {
      $id = hashed($id,'d');
      if ($this->crud->delete('faqs', 'id', $id)) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'FAQ Deleted!');
        $this->session->set_flashdata('msg', 'FAQ has been deleted successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to delete the FAQ due to error!');
      }
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
    }
    return redirect(base_url('superadmin/manageFaqs.html'));
  }
  public function newsletter()
  {
    $config['seoTitle'] = 'Manage Newsletter';
    $this->load->view('secure/inc/header', $config);
    $this->load->view('secure/manage-newsletter');
    $this->load->view('secure/inc/footer');
  }
  public function deleteSubscriber($id)
  {
    if ($this->crud->delete('newsletters', 'id', hashed($id,'d'))) {
      $this->session->set_flashdata('type', 'success');
      $this->session->set_flashdata('title', 'Deleted Successfully!');
      $this->session->set_flashdata('msg', 'The entry has been removed successfully.');
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error Occured!');
      $this->session->set_flashdata('msg', 'Unable to delete the entry!');
    }
    return redirect(base_url('superadmin/newsletter.html'));
  }
  // Booking
  public function bookings()
  {
    $config['seoTitle'] = 'Manage Bookings Messages';
    $this->load->view('secure/inc/header', $config);
    $this->load->view('secure/manage-bookings');
    $this->load->view('secure/inc/footer');
  }
  public function fetchSingleBookingMessage()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      $mid = hashed($this->input->post('mid'),'d');
      $type = hashed($this->input->post('type'),'d');
      $message = $this->crud->getDataSingle('bookings', $mid, 'id', null);
      if ($this->crud->getCount('bookings', 'id', $mid) > 0) {
        $this->crud->update('bookings', 'id', $mid, ['status'=>'read']);
        $prop = @$this->crud->getDataSingle('property', $message->pid, 'id', null);
        $res = 'fetched';
        $subject = '<i class="fas fa-envelope"></i> '.ucwords($message->subject);
        $body = '
        <table class="table table-striped table-hover">
        <tr>
        <th>Booking Date & Time</th>
        <td>'.date('d M, Y - h:i A', strtotime($message->datetime)).'</td>
        </tr>
        <tr>
        <th>Property</th>
        <td><a href="'.base_url('property/'.@$prop->uri.'.html').'" target="_blank">'.@$prop->title.' ('.@$prop->property_id.')'.'</a></td>
        </tr>
        <tr>
        <th>Name</th>
        <td>'.ucwords($message->name).'</td>
        </tr>
        <tr>
        <th>Phone</th>
        <td>'.$message->phone.'</td>
        </tr>
        <tr>
        <th>Email</th>
        <td>'.$message->email.'</td>
        </tr>
        <tr>
        <th>Line ID</th>
        <td>'.$message->line_id.'</td>
        </tr>
        <tr>
        <th>Address</th>
        <td>'.$message->address.'</td>
        </tr>
        </table>
        ';
      }else {
        $res = 'error';
        $subject = 'Message Not Found!';
        $body = 'The requested message has not been found!';
      }
      $output = array(
        'status' => $res,
        'subject' => $subject,
        'msg' => $body,
      );
      echo json_encode($output);
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('superadmin.html'));
    }
  }
  public function starBooking($status=null,$mid=null)
  {
    if (!empty($status) && !empty($mid)) {
      if ($this->crud->update('bookings', 'id', hashed(cleanVal($mid),'d'), ['star'=>cleanVal($status)])) {
        $this->session->set_flashdata('type', 'success');
        if (cleanVal($status) == 'yes') {
          $this->session->set_flashdata('title', 'Booking Marked As Important!');
          $this->session->set_flashdata('msg', 'The booking has been marked as important successfully.');
        }else {
          $this->session->set_flashdata('title', 'Booking Marked As Unimportant!');
          $this->session->set_flashdata('msg', 'The booking has been marked as unimportant successfully.');
        }
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to process your request!');
      }
      return redirect(base_url('superadmin/bookings.html'));
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url());
    }
  }
  public function deleteBooking($mid=null)
  {
    if (!empty($mid)) {
      $mid = hashed(cleanVal($mid),'d');
      if ($this->crud->delete('bookings', 'id', $mid)) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Booking Deleted!');
        $this->session->set_flashdata('msg', 'The booking details has been deleted successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to process your request!');
      }
      return redirect(base_url('superadmin/bookings.html'));
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('superadmin.html'));
    }
  }
  // AJAX Save Content
  public function save_content()
  {
    $this->load->helper('string');
    $content = $this->input->post('content'); // Get the content from POST data
    // Auto-generate the cid
    $cid = random_string('alnum', 16); // Generates a random 8-character alphanumeric string
    // Prepare data for insertion
    $data = array(
      'cid' => $cid,
      'content' => $content
    );
    // Insert into the database using model
    $insert_id = $this->crud->save('contents', $data, TRUE);
    if ($insert_id) {
      // Send the `cid` back as a response
      echo json_encode(array('cid' => $cid));
    } else {
      echo json_encode(array('error' => 'Failed to save content.'));
    }
  }
  public function exportBookings() {
    if ($this->session->userdata('role') != 'admin') {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Unauthorized Access!');
      $this->session->set_flashdata('msg', 'You are not authorized to access!');
      return redirect(base_url('superadmin/bookings.html'));
    }
    // Turn on output buffering
    ob_start();
    // Load the CSV helper
    $this->load->helper('download');
    // Get data from the database
    $bookings = $this->crud->getDataAll('bookings', 'id', 'desc');
    // Open output buffer to write CSV content
    $csv_data = fopen('php://output', 'w');
    // Define CSV headers (same as the table fields)
    $header = array('subject', 'property', 'appointment', 'name', 'phone', 'email', 'line_id', 'address', 'created');
    fputcsv($csv_data, $header);
    // Loop through bookings and write each row to CSV
    foreach ($bookings as $booking) {
      $prop = @$this->crud->getDataSingle('property', $booking->pid, 'id', null);
      $row = array(
        @$booking->subject,
        @$prop->title.' ('.@$prop->property_id.')',
        date('d M, Y - h:ia', strtotime(@$booking->datetime)),
        @$booking->name,
        @$booking->phone,
        @$booking->email,
        @$booking->line_id,
        @$booking->address,
        date('d M, Y - h:ia', strtotime(@$booking->created))
      );
      fputcsv($csv_data, $row);
    }
    // Close output buffer
    fclose($csv_data);
    // Set headers to force download
    header('Content-Type: application/csv');
    header('Content-Disposition: attachment; filename="bookings-'.date('d-m-Y').'.csv";');
    header('Pragma: no-cache');
    header('Expires: 0');
    // Flush the output buffer
    ob_end_flush();
    exit;
  }
  public function exportContactMessages() {
    if ($this->session->userdata('role') != 'admin') {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Unauthorized Access!');
      $this->session->set_flashdata('msg', 'You are not authorized to access!');
      return redirect(base_url('superadmin/messages.html'));
    }
    // Turn on output buffering
    ob_start();
    // Load the CSV helper
    $this->load->helper('download');
    // Get data from the database
    $bookings = $this->crud->getDataAll('records', 'id', 'desc');
    // Open output buffer to write CSV content
    $csv_data = fopen('php://output', 'w');
    // Define CSV headers (same as the table fields)
    $header = array('name', 'phone', 'email', 'messages', 'created');
    fputcsv($csv_data, $header);
    // Loop through bookings and write each row to CSV
    foreach ($bookings as $booking) {
      $prop = @$this->crud->getDataSingle('property', $booking->pid, 'id', null);
      $row = array(
        @$booking->name,
        @$booking->phone,
        @$booking->email,
        @$booking->message,
        date('d M, Y - h:ia', strtotime(@$booking->created))
      );
      fputcsv($csv_data, $row);
    }
    // Close output buffer
    fclose($csv_data);
    // Set headers to force download
    header('Content-Type: application/csv');
    header('Content-Disposition: attachment; filename="contact-messages-'.date('d-m-Y').'.csv";');
    header('Pragma: no-cache');
    header('Expires: 0');
    // Flush the output buffer
    ob_end_flush();
    exit;
  }
  public function exportNewsletter() {
    if ($this->session->userdata('role') != 'admin') {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Unauthorized Access!');
      $this->session->set_flashdata('msg', 'You are not authorized to access!');
      return redirect(base_url('superadmin/newsletter.html'));
    }
    // Turn on output buffering
    ob_start();
    // Load the CSV helper
    $this->load->helper('download');
    // Get data from the database
    $newsletters = $this->crud->getDataAll('newsletters', 'id', 'desc');
    // Open output buffer to write CSV content
    $csv_data = fopen('php://output', 'w');
    // Define CSV headers (same as the table fields)
    $header = array('email', 'status', 'ip', 'added');
    fputcsv($csv_data, $header);
    // Loop through bookings and write each row to CSV
    foreach ($newsletters as $newsletter) {
      $row = array(
        @$newsletter->email,
        @$newsletter->status == '1' ? 'Opt In':'Opt Out',
        @$newsletter->ip,
        date('d M, Y - h:ia', strtotime(@$newsletter->added))
      );
      fputcsv($csv_data, $row);
    }
    // Close output buffer
    fclose($csv_data);
    // Set headers to force download
    header('Content-Type: application/csv');
    header('Content-Disposition: attachment; filename="newsletter-'.date('d-m-Y').'.csv";');
    header('Pragma: no-cache');
    header('Expires: 0');
    // Flush the output buffer
    ob_end_flush();
    exit;
  }
  public function manageTeam()
  {
    $data['seoTitle'] = 'Manage Team';
    $this->load->view('secure/inc/header',$data);
    $this->load->view('secure/manage-team');
    $this->load->view('secure/inc/footer');
  }
  public function saveTeamDetails()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      $data['name'] = $this->input->post('name') ?? null;
      $data['position'] = $this->input->post('position') ?? null;
      $data['linkedin'] = $this->input->post('linkedin') ?? null;
      // File upload configuration
      $config['upload_path']   = './upload/team/';
      $config['allowed_types'] = 'gif|jpg|jpeg|png|webp|svg';
      $config['max_size']      = 10240; // 10MB in kilobytes
      $config['file_ext_tolower'] = TRUE;
      $config['encrypt_name']  = TRUE;
      $this->load->library('upload', $config);
      // Check if a file is selected
      if (isset($_FILES['photos']) && !empty($_FILES['photos']['name'])) {
        if (!$this->upload->do_upload('photos')) {
          // Upload failed, set flash data and redirect
          $this->session->set_flashdata('type', 'error');
          $this->session->set_flashdata('title', 'Upload Error');
          $this->session->set_flashdata('msg', $this->upload->display_errors());
          return redirect(base_url('superadmin/manageTeam.html'));
        } else {
          // Upload success, get the data
          $uploadData = $this->upload->data();
          $data['photos'] = 'upload/team/' . $uploadData['file_name'];
        }
      }
      // Save the testimonial data to the database
      if ($this->crud->save('team', $data, false)) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Data Saved!');
        $this->session->set_flashdata('msg', 'The team member details have been saved successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occurred!');
        $this->session->set_flashdata('msg', 'Unable to save the details!');
      }
      return redirect(base_url('superadmin/manageTeam.html'));
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('superadmin.html'));
    }
  }
  public function updateTeamDetails()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      $id = $this->input->post('id');
      $data['name'] = $this->input->post('name');
      $data['position'] = $this->input->post('position');
      $data['linkedin'] = $this->input->post('linkedin');
      // File upload configuration
      $config['upload_path']   = './upload/team/';
      $config['allowed_types'] = 'gif|jpg|jpeg|png|webp|svg';
      $config['max_size']      = 10240; // 10MB in kilobytes
      $config['file_ext_tolower'] = TRUE;
      $config['encrypt_name']  = TRUE;
      $this->load->library('upload', $config);
      // Check if a file is selected
      if (isset($_FILES['photos']) && !empty($_FILES['photos']['name'])) {
        if (!$this->upload->do_upload('photos')) {
          // Upload failed, set flash data and redirect
          $this->session->set_flashdata('type', 'error');
          $this->session->set_flashdata('title', 'Upload Error');
          $this->session->set_flashdata('msg', $this->upload->display_errors());
          return redirect(base_url('superadmin/manageTeam.html'));
        } else {
          // Upload success, get the data
          $uploadData = $this->upload->data();
          $data['photos'] = 'upload/team/' . $uploadData['file_name'];
        }
      }
      // Save the testimonial data to the database
      if ($this->crud->update('team', 'id', $id, $data)) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Data Updated!');
        $this->session->set_flashdata('msg', 'The team member details have been updated successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occurred!');
        $this->session->set_flashdata('msg', 'Unable to save the details!');
      }
      return redirect(base_url('superadmin/manageTeam.html'));
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('superadmin.html'));
    }
  }
  public function deleteTeamDetails($id=null)
  {
    if (!empty($id) && $this->crud->getCount('team', 'id', $id) > 0) {
      if ($this->crud->delete('team', 'id', $id)) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Data Deleted!');
        $this->session->set_flashdata('msg', 'The team member details have been deleted successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occurred!');
        $this->session->set_flashdata('msg', 'Unable to delete the details!');
      }
      return redirect(base_url('superadmin/manageTeam.html'));
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('superadmin.html'));
    }
  }
  public function managePages()
  {
    $data['seoTitle'] = 'Manage Page';
    $this->load->view('secure/inc/header',$data);
    $this->load->view('secure/manage-pages');
    $this->load->view('secure/inc/footer');
  }
}
?>
