<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Property  extends CI_Model {

    // Fetch properties with filters and pagination
    public function get_filtered_properties($params = [], $limit, $offset) {
        $this->db->select('*');
        $this->db->from('property');

        // Apply filters if they exist
        if (!empty($params['property_type'])) {
            $this->db->where('property_type', $params['property_type']);
        }

        if (!empty($params['property_status'])) {
            $this->db->where('property_status', $params['property_status']);
        }

        if (!empty($params['bedrooms'])) {
            $this->db->where('bedrooms >=', (int) $params['bedrooms']);
        }

        if (!empty($params['bathrooms'])) {
            $this->db->where('bathrooms >=', (int) $params['bathrooms']);
        }

        if (!empty($params['location'])) {
            $this->db->like('location', $params['location']);
        }

        if (!empty($params['minbudget'])) {
            $this->db->where('price >=', (int) $params['minbudget']);
        }

        if (!empty($params['maxbudget'])) {
            $this->db->where('price <=', (int) $params['maxbudget']);
        }

        // Set limit and offset for pagination
        $this->db->limit($limit, $offset);

        // Execute the query
        $query = $this->db->get();
        return $query->result_array();
    }

    // Get total count for pagination
    public function count_filtered_properties($params = []) {
        $this->db->select('id');
        $this->db->from('property');

        // Apply filters if they exist
        if (!empty($params['property_type'])) {
            $this->db->where('property_type', $params['property_type']);
        }

        if (!empty($params['property_status'])) {
            $this->db->where('property_status', $params['property_status']);
        }

        if (!empty($params['bedrooms'])) {
            $this->db->where('bedrooms >=', (int) $params['bedrooms']);
        }

        if (!empty($params['bathrooms'])) {
            $this->db->where('bathrooms >=', (int) $params['bathrooms']);
        }

        if (!empty($params['location'])) {
            $this->db->like('location', $params['location']);
        }

        if (!empty($params['minbudget'])) {
            $this->db->where('price >=', (int) $params['minbudget']);
        }

        if (!empty($params['maxbudget'])) {
            $this->db->where('price <=', (int) $params['maxbudget']);
        }

        // Execute the query
        return $this->db->count_all_results();
    }
}
