<?php
  if (!empty($page)) {
    if ($page == 'location' && !empty($this->input->get('location'))) {
      $locationData = @$this->crud->getDataSingle('locations', $this->input->get('location'), 'uri', null);
      $seoTitle = 'Properties in '.@$locationData->title;
      $seoDesc =  'Properties in '.@$locationData->title;
      $seoKeys =  @$locationData->title.', Accel';
      $seoCanonical =  base_url('location.html');
    } else {
      $pageData = @$this->crud->getDataSingle('page', $page, 'pid', null);
      $seoTitle = @$pageData->seo_title;
      $seoDesc =  @$pageData->seo_description;
      $seoKeys =  @$pageData->seo_keywords;
      $seoCanonical =  @$pageData->canonical ?? current_url();
    }
  }else {
    $seoCanonical = current_url();
  }

?>
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title><?=(!empty($seoTitle))?$seoTitle:'Accel' ?></title>
  <meta name="description" content="<?=(!empty($seoDesc))?$seoDesc:'Accel' ?>" />
  <meta name=”keywords” content="<?=(!empty($seoKeys))?$seoKeys:'Accel' ?>">
  <meta name="author" content="WebsiteProvide-KrishnaJaiKumar">
  <link rel="canonical" href="<?=$seoCanonical ?>" />

  <!-- Open Graph / Facebook -->
<meta property="og:type" content="website" />
<meta property="og:title" content="<?=(!empty($seoTitle))?$seoTitle:'Accel' ?>" />
<meta property="og:description" content="<?=(!empty($seoDesc))?$seoDesc:'Accel' ?>" />
<meta property="og:url" content="<?=$seoCanonical ?>" />
<meta property="og:image" content="<?=base_url('assets/img/accel.svg')?>" />

<!-- Twitter -->
<meta name="twitter:card" content="summary_large_image" />
<meta name="twitter:title" content="<?=(!empty($seoTitle))?$seoTitle:'Accel' ?>" />
<meta name="twitter:description" content="<?=(!empty($seoDesc))?$seoDesc:'Accel' ?>" />
<meta name="twitter:image" content="<?=base_url('assets/img/accel.svg')?>" />


  <link rel="icon" href="<?=base_url('assets/')?>img/favicon.jpg" type="image/x-icon">
  <link rel="apple-touch-icon" href="<?=base_url('assets/')?>img/favicon.jpg">
  <link rel="shortcut icon" type="image/x-icon" href="<?=base_url('assets/')?>img/favicon.jpg">
  <!-- css -->
  <link rel="stylesheet" type="text/css" href="<?=base_url('assets/')?>css/choices.min.css">
  <link rel="stylesheet" type="text/css" href="<?=base_url('assets/')?>css/daterangepicker.css" />
  <link rel="stylesheet" type="text/css" href="<?=base_url('assets/')?>css/jquery.fancybox-3.5.7.min.css"  media="screen" />
  <link rel="stylesheet" type="text/css" href="<?=base_url('assets/')?>css/comnon.css">
  <link rel="stylesheet" type="text/css" href="<?=base_url('assets/')?>vendors/pm-price-range-slider.css">
  <!-- js -->
  <script type="text/javascript" src="<?=base_url('assets/')?>js/jquery-3.7.1.min.js"></script>
  <script type="text/javascript" src="<?=base_url('assets/')?>js/jquery.fancybox-3.5.7.min.js"></script>
  <script type="text/javascript" src="<?=base_url('assets/')?>js/moment.min.js"></script>
  <script type="text/javascript" src="<?=base_url('assets/')?>js/daterangepicker.min.js"></script>
  <script type="text/javascript" src="<?=base_url('assets/')?>js/choices.min.js"></script>
  <script type="text/javascript" src="<?=base_url('assets/')?>vendors/pm-price-range-slider.js"></script>
  <?php
  $minbudget = !empty($this->input->get('minbudget')) ? $this->input->get('minbudget'): '0';
  $maxbudget = !empty($this->input->get('maxbudget')) ? $this->input->get('maxbudget'): '2000000';
  ?>
  <script>
  // Trigger
  $(function () {
    var $range = $(".js-range-slider"),
    $inputFrom = $(".js-input-from"),
    $inputTo = $(".js-input-to"),
    instance,
    min = 10000,
    max = 100000000,
    from = <?=$minbudget ?>,
    to = <?=$maxbudget ?>;
    $range.ionRangeSlider({
      type: "double",
      min: min,
      max: max,
      from: <?=$minbudget ?>,
      to: <?=$maxbudget ?>,
      prefix: '฿',
      onStart: updateInputs,
      onChange: updateInputs,
      step: 100000,
      prettify_enabled: true,
      prettify_separator: "",
      values_separator: " - ",
      force_edges: true
    });
    instance = $range.data("ionRangeSlider");
    function updateInputs (data) {
      from = data.from;
      to = data.to;
      $inputFrom.prop("value", from);
      $inputTo.prop("value", to);
    }
    $inputFrom.on("input", function () {
      var val = $(this).prop("value");
      // validate
      if (val < min) {
        val = min;
      } else if (val > to) {
        val = to;
      }
      instance.update({
        from: val
      });
    });
    $inputTo.on("input", function () {
      var val = $(this).prop("value");
      // validate
      if (val < from) {
        val = from;
      } else if (val > max) {
        val = max;
      }
      instance.update({
        to: val
      });
    });
  });
  </script>
  <?php if (isset($_SESSION['su'])): ?>
    <style media="screen">
    iframe#\:1\.container {
      position: fixed;
      top: -5px;
      height: 0;
    }
    .choices__list--dropdown {
      z-index: 11;
    }
    /* Override or extend Bootstrap's btn-dark styles */
    /* Custom styles for the edit button */
    .editButton {
      background-color: #343a40;
      color: #fff;
      border: none;
      padding: 0px 8px;
      border-radius: 5px;
      display: inline-flex;
      align-items: center;
      font-size: 12px;
      cursor: pointer;
      transition: background-color 0.3s ease;
    }
    .editButton svg {
      margin-right: 5px; /* Space between the icon and text */
      width: 12px;
      height: 12px;
      fill: currentColor; /* Makes the SVG inherit the button's text color */
    }
    .editButton:hover {
      background-color: #23272b; /* Darker background on hover */
    }
    .editButton:focus {
      outline: none;
      background-color: #1d2124; /* Even darker when focused */
      box-shadow: 0 0 4px rgba(0, 0, 0, 0.3); /* Focus shadow */
    }
    </style>
    <style>
    /* General Modal Styling */
    .modal {
      display: none; /* Hidden by default */
      position: fixed;
      z-index: 1000; /* Place the modal in front */
      left: 0;
      top: 0;
      width: 100%;
      height: 100%;
      background-color: rgba(0, 0, 0, 0.5); /* Black background with opacity */
      justify-content: center;
      align-items: center;
    }
    .modal-content {
      background-color: #fff;
      padding: 20px;
      border-radius: 10px;
      width: 400px;
      max-width: 90%;
      box-shadow: 0 5px 15px rgba(0, 0, 0, 0.3);
    }
    /* Modal Header */
    .modal-header {
      font-size: 18px;
      margin-bottom: 10px;
      text-align: center;
    }
    /* Close Button */
    .close {
      position: absolute;
      right: 15px;
      top: 10px;
      font-size: 24px;
      color: #000;
      cursor: pointer;
    }
    .close:hover {
      color: red;
    }
    /* Textarea */
    .modal textarea {
      width: 100%;
      height: 150px;
      padding: 10px;
      border-radius: 5px;
      border: 1px solid #ccc;
      font-size: 14px;
    }
    /* Save Button */
    .save-btn {
      background-color: #343a40;
      color: #fff;
      padding: 10px 20px;
      border: none;
      border-radius: 5px;
      cursor: pointer;
      margin-top: 10px;
      width: 100%;
      font-size: 16px;
    }
    .save-btn:hover {
      background-color: #23272b;
    }
    /* Loader styles */
    #pmLoader {
      display: none; /* Hidden by default */
      position: fixed; /* Fixed position */
      left: 50%; /* Center horizontally */
      top: 50%; /* Center vertically */
      transform: translate(-50%, -50%); /* Adjust position to truly center */
      z-index: 1000; /* Ensure it's above other content */
    }
    .loader {
      border: 8px solid #f3f3f3; /* Light gray border */
      border-top: 8px solid #3498db; /* Blue top border */
      border-radius: 50%; /* Circular shape */
      width: 60px; /* Width of the loader */
      height: 60px; /* Height of the loader */
      animation: spin 1s linear infinite; /* Spin animation */
    }
    /* Animation for spinning */
    @keyframes spin {
      0% { transform: rotate(0deg); }
      100% { transform: rotate(360deg); }
    }
    </style>
    <script>
    let currentCid = null;
    // Function to trigger the modal and populate the textarea with the current content
    function updateContent(cid) {
      showLoader()
      currentCid = cid;
      // For demonstration, we'll use a static text. Replace this with a call to fetch the actual content from the server if needed
      $.ajax({
        url: '<?=base_url('get-content')?>',
        type: 'post',
        dataType: 'html',
        data: {currentCid:currentCid}
      })
      .done(function(res) {
        hideLoader();
        document.getElementById('contentBox').value = res;
        document.getElementById('cencid').value = currentCid;
        document.getElementById('contentModal').style.display = 'flex';
      })
      .fail(function() {
        hideLoader();
        console.log("error");
      })
      .always(function() {
        console.log("complete");
      });
    }
    // Function to close the modal
    function closeModal() {
      hideLoader();
      document.getElementById('contentModal').style.display = 'none';
    }
    // Function to save the content
    function saveContent() {
      const updatedContent = document.getElementById('contentBox').value;
      // Perform an AJAX request here to save the content to the server
      console.log("Saving content for CID: " + currentCid);
      console.log("Updated Content: " + updatedContent);
      // Close the modal after saving
      closeModal();
    }
    // Close the modal when clicking outside of the content box
    window.onclick = function(event) {
      const modal = document.getElementById('contentModal');
      if (event.target === modal) {
        closeModal();
      }
    }
    function showLoader() {
      document.getElementById('pmLoader').style.display = 'flex';
    }
    // Function to hide the loader
    function hideLoader() {
      document.getElementById('pmLoader').style.display = 'none';
    }
    </script>
  <?php endif; ?>
  <style>
  /* Container for pagination */
  .pagination-box {
    margin: 20px 0;
    display: flex;
    justify-content: center;
  }
  /* Pagination container */
  .pagination {
    list-style: none;
    padding: 0;
    display: flex;
  }
  /* Pagination links */
  .pagination li a {
    display: block;
    padding: 10px 15px;
    margin: 0 5px;
    background-color: #f8f9fa; /* Light background */
    border: 1px solid #dee2e6;
    color: #06486f; /* Bootstrap blue color */
    text-decoration: none;
    border-radius: 4px;
    transition: all 0.3s ease;
  }
  .pagination li a:hover {
    background-color: #06486f;
    color: #fff; /* Change to white on hover */
    border-color: #06486f;
  }
  /* Active page styling */
  .pagination li.active a {
    background-color: #06486f;
    color: white;
    border-color: #06486f;
    cursor: default;
  }
  /* Disabled state */
  .pagination li.disabled a {
    background-color: #e9ecef;
    color: #6c757d;
    border-color: #dee2e6;
    pointer-events: none;
    cursor: not-allowed;
  }
  /* Previous and Next links styling */
  .pagination li.page-item a {
    padding: 10px 15px;
  }
  .pagination li.page-item:first-child a {
    border-top-left-radius: 4px;
    border-bottom-left-radius: 4px;
  }
  .pagination li.page-item:last-child a {
    border-top-right-radius: 4px;
    border-bottom-right-radius: 4px;
  }
  /* Smaller screens responsiveness */
  @media (max-width: 768px) {
    .pagination li a {
      padding: 8px 12px;
      font-size: 14px;
    }
  }
  </style>
</head>
<body>
  <!-- Loader -->
  <div id="pmLoader">
    <div class="loader"></div>
  </div>
  <!-- header -->
  <header class="header-v1">
    <div class="custom-container">
      <nav class="Nav-top flex-js-b">
        <div class="navbar-header">
          <a href="<?=base_url()?>"><img src="<?=base_url('assets/')?>img/accel.svg" height="32" alt="Logo"></a>
        </div>
        <div class="menuToggle">
          <span class="overlay-input"><span></span></span>
        </div>
        <div class="nav-right mobileview" id="">
          <ul class="nav-ul flex-acenter ml-auto ">
            <li class="nav-li"><a href="<?=base_url('buy.html')?>">Buy</a></li>
            <li class="nav-li"><a href="<?=base_url('rent.html')?>">Rent</a></li>
            <li class="nav-li"><a href="<?=base_url('about.html')?>">About</a></li>
            <li class="nav-li"><a href="<?=base_url('contact.html')?>">Contact</a></li>
            <li class="nav-li"><div class="custom-lang" id="google_translate_element"></div></li>
          </ul>
          <div class="max-dp"></div>
        </div>
      </nav>
    </div>
  </header>
  <!-- header -->
