<?php
if (!empty($prp->cover_photo)) {
  $imgPath = $prp->cover_photo;
} else {
  $imgPath = 'upload/cover-photo/buildingbg.jpg';
}
?>
<section class="listing-data-pg bc-gray">
  <div class="custom-container flex-col gap-24">
    <div class="listing-name flex-js-b flex-acenter ptb-32">
      <div class="flex-acenter">
        <img class="img-responsive tumbs-img-listing b-radius-4" src="<?=base_url(($imgPath))?>" alt="Property listing">
        <div class="list-pro-heading">
          <div class="type-pro flex-acenter">
            <h1 class="pro-name"><?=strtoupper($prp->title) ?></h1>
            <span class="color-gray"> Located in <span
              class="color-black"><?=@$this->crud->getDataSingle('locations', $prp->location, 'uri', null)->title ?></span></span>
            </div>
            <p class="color-gray"><?=ucwords($prp->project_type) ?></p>
          </div>
        </div>
       <!-- <a class="link-info" href="<//?=base_url()?>">go back</a> -->
      </div>
      <!-- name of list -->
      <!-- listing light box -->
      <div class="dflex gap-1 gallery-wrap">
        <div class="width-850 gallery pos-relative" >
          <?php if (!empty($prp->cover_photo) && file_exists($prp->cover_photo)): ?>
            <a href="<?=base_url($prp->cover_photo)?>">
              <img class="img-responsive banner-listing" src="<?=base_url($prp->cover_photo)?>" alt="<?=$prp->title ?>">
            </a>
          <?php endif; ?>
          <span class="btn-white see-photos">See all photos</span>
        </div>
        <div class="width-414 grids-2 gap-1 gallery-tumbs gallery"  style="height: 415px; overflow-y: scroll;">
          <?php if ($this->crud->getCountGalleryItem($prp->id,'photo') > 0): ?>
            <?php foreach ($this->crud->getDataSingle('gallery', $prp->id, 'pid', true) as $photo): ?>
              <?php if (file_exists($photo->src)): ?>
                <a href="<?=base_url($photo->src)?>">
                  <img class="img-responsive tumbs-listing" src="<?=base_url($photo->src)?>" alt="<?=$prp->title ?>">
                </a>
              <?php endif; ?>
            <?php endforeach; ?>
          <?php endif; ?>
        </div>
      </div>
      <!-- listing light box -->
      <!-- listing light box -->
      <div class="dflex gap-1 amenitie-wrap">
        <div class="width-850 card-component amenitie-list">
          <div class="flex-col gap-24">
            <h2 class="fs-24">Amenities</h2>
            <ul class="amenitie-ul">
              <?php $amenities = explode(',', $prp->amenities) ?>
              <?php if (is_array($amenities)): ?>
                <?php foreach ($amenities as $amenity): ?>
                  <li class="amenitie-li">
                    <span class="amenitie-icon">
                      <img class="img-responsive icons-listing" src="<?=base_url('assets/icons/check-circle.svg')?>" alt="Flat">
                    </span> <?=$amenity ?>
                  </li>
                <?php endforeach; ?>
              <?php endif; ?>
            </ul>
            <!--
            <div class="amenitie-more dflex justify-end">
              <a hree="#" class="btn-white">See all amenities</a>
            </div> -->
          </div>
        </div>
        <div class="width-414 card-component">
          <div class="flex-col gap-24">
            <span class="w-100 text-center radius-btn"><?=$prp->discount_message ?></span>
            <ul class="div-list">
              <li class="price-li flex-col">
                <p class="color-gray"> Selling Price</p>
                <p class="fs-24">
                  <?php if (!empty($prp->price)): ?>
                    ฿ <?=$this->cart->format_number($prp->price) ?>
                  <?php endif; ?>
                </p>
                <p class="color-gray"> Negotiable</p>
                <p class="diveder-div"></p>
              </li>
              <li class="price-li flex-col">
                <p class="color-gray"> Rental Price</p>
                <p class="fs-24">
                  <?php if (!empty($prp->price_rent)): ?>
                    ฿ <?=$this->cart->format_number($prp->price_rent) ?>
                  <?php endif; ?>
                </p>
                <p class="color-gray">/month</p>
                <p class="diveder-div"></p>
              </li>
            </ul>
            <a class="w-100 text-center btn-100 btn-bg" href="#book_fm">Enquire Now </a>
          </div>
        </div>
      </div>
      <!-- listing  text summary -->
      <div class="card-component editor-div">
        <h2 class="fs-24">About this listing</h2>
        <?=@$prp->description ?>
      </div>
      <!-- listing  google api -->
      <div class="dflex gap-1 amenitie-wrap">
        <div class="width-850 card-component address-list">
          <h2 class="fs-24">Listing detail</h2>
          <?php if (!empty($prp->address_map)): ?>
            <div class="map-address mtb-24">
              <?php $mapURL = extract_map_url($prp->address_map) ?>
              <iframe title="map address" src="<?=$mapURL ?>"  height="330" style="border:0;" allowfullscreen="" loading="lazy" referrerpolicy="no-referrer-when-downgrade"></iframe>
            </div>
          <?php endif; ?>
          <div class="editor-div">
            <!-- <div class="map-nearby">
              <h3>Nearby Places</h3>
              <ul class="amenitie-ul">
                <?php $places_nearby = explode(',', $prp->places_nearby) ?>
                <?php if (is_array($places_nearby)): ?>
                  <?php foreach ($places_nearby as $placesNearby): ?>
                    <li class="amenitie-li">
                      <span class="amenitie-icon">
                        <img class="img-responsive icons-listing" src="<?=base_url('assets/icons/check-circle.svg')?>" alt="Flat">
                      </span> <?=$placesNearby ?>
                    </li>
                  <?php endforeach; ?>
                <?php endif; ?>
              </ul>
            </div> -->
            <div class="map-nearby">
              <div class="main-title-4">
                <h1><span>Other Details</span></h1>
              </div>
              <div class="row">
                <div class="col-md-4 col-sm-4 col-xs-12">
                  <ul class="amenitie-ul">
                    <?php if (!empty($prp->property_id)): ?>
                      <li class="amenitie-li">
                        <span class="amenitie-icon">
                          <img class="img-responsive icons-listing" src="<?=base_url('assets/icons/check-circle.svg')?>" alt="Flat">
                        </span>
                        Property ID : <?=ucwords($prp->property_id) ?>
                      </li>
                    <?php endif; ?>
                    <?php if (!empty($prp->price)): ?>
                      <li class="amenitie-li">
                        <span class="amenitie-icon">
                          <img class="img-responsive icons-listing" src="<?=base_url('assets/icons/check-circle.svg')?>" alt="Flat">
                        </span>
                        Price : <?=$this->crud->getSetting('currencySymbol') ?><?=$prp->price ?>
                      </li>
                    <?php endif; ?>
                    <?php if (!empty($prp->property_type)): ?>
                      <li class="amenitie-li">
                        <span class="amenitie-icon">
                          <img class="img-responsive icons-listing" src="<?=base_url('assets/icons/check-circle.svg')?>" alt="Flat">
                        </span>
                        Property Type :
                        <a href="<?=base_url('property/'.$prp->uri.'.html')?>">
                          <?=$prp->property_type ?>
                        </a>
                      </li>
                    <?php endif; ?>
                    <?php if (!empty($prp->additional_rooms)): ?>
                      <li class="amenitie-li">
                        <span class="amenitie-icon">
                          <img class="img-responsive icons-listing" src="<?=base_url('assets/icons/check-circle.svg')?>" alt="Flat">
                        </span>
                        Additional Rooms : <?=$prp->additional_rooms ?>
                      </li>
                    <?php endif; ?>
                  </ul>
                </div>
                <div class="col-md-4 col-sm-4 col-xs-12">
                  <ul class="amenitie-ul">
                    <?php if (!empty($prp->property_size)): ?>
                      <li class="amenitie-li">
                        <span class="amenitie-icon">
                          <img class="img-responsive icons-listing" src="<?=base_url('assets/icons/check-circle.svg')?>" alt="Flat">
                        </span>
                        Property Size : <?=$prp->property_size ?>
                      </li>
                    <?php endif; ?>
                    <?php if (!empty($prp->year_built)): ?>
                      <li class="amenitie-li">
                        <span class="amenitie-icon">
                          <img class="img-responsive icons-listing" src="<?=base_url('assets/icons/check-circle.svg')?>" alt="Flat">
                        </span>
                        Year Built : <?=$prp->year_built ?>
                      </li>
                    <?php endif; ?>
                    <?php if (!empty($prp->property_status)): ?>
                      <li class="amenitie-li">
                        <span class="amenitie-icon">
                          <img class="img-responsive icons-listing" src="<?=base_url('assets/icons/check-circle.svg')?>" alt="Flat">
                        </span>
                        Property Status : <?=$prp->property_status ?>
                      </li>
                    <?php endif; ?>
                  </ul>
                </div>
                <div class="col-md-4 col-sm-4 col-xs-12">
                  <ul class="amenitie-ul">
                    <?php if (!empty($prp->bedrooms)): ?>
                      <li class="amenitie-li">
                        <span class="amenitie-icon">
                          <img class="img-responsive icons-listing" src="<?=base_url('assets/icons/check-circle.svg')?>" alt="Flat">
                        </span>
                        Bedrooms : <?=$prp->bedrooms ?>
                      </li>
                    <?php endif; ?>
                    <?php if (!empty($prp->bathrooms)): ?>
                      <li class="amenitie-li">
                        <span class="amenitie-icon">
                          <img class="img-responsive icons-listing" src="<?=base_url('assets/icons/check-circle.svg')?>" alt="Flat">
                        </span>
                        Bathrooms : <?=$prp->bathrooms ?>
                      </li>
                    <?php endif; ?>
                    <?php if (!empty($prp->deposit)): ?>
                      <li class="amenitie-li">
                        <span class="amenitie-icon">
                          <img class="img-responsive icons-listing" src="<?=base_url('assets/icons/check-circle.svg')?>" alt="Flat">
                        </span>
                        Deposit : <?=$prp->deposit ?>
                      </li>
                    <?php endif; ?>
                  </ul>
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="width-414 card-component" id="book_fm">
          <h2 class="fs-24 mb-24">Book a visits or consultation</h2>
          <?=form_open(base_url('process-booking-request.html'),['class'=>'form-booking flex-col gap-1']) ?>
            <div class="div-fm ">
              <label for="date">Appointment Date & Time</label>
              <input class="datetimepicker input-box" name="datetime" type="text" placeholder="Date-Time" required>
            </div>
            <div class="div-fm ">
              <label for="date">Subject</label>
              <select class="form-select selectpicker" name="subject" aria-label="Default select example" required>
                <option selected>Select subject</option>
                <option value="inquiry">Enquiry</option>
                <option value="site inspection">Site Inspection</option>
                <option value="sale">Sale</option>
                <option value="purchase">Purchase</option>
              </select>
            </div>
            <div class="div-fm ">
              <label for="date">your name</label>
              <input class="input-box" name="name" type="text" placeholder="Enter your name" required>
            </div>
            <div class="div-fm ">
              <label for="date">contact number</label>
              <input class="input-box" name="phone" type="text" placeholder="Enter Phone number" required>
            </div>
            <div class="div-fm ">
              <label for="date">your Line ID</label>
              <input class="input-box" name="line_id" type="text" placeholder="Enter Line ID (Optional)">
            </div>
            <div class="div-fm ">
              <label for="date">email address</label>
              <input class="input-box" name="email" type="email" placeholder="Enter your email address" required>
            </div>
            <div class="div-fm ">
              <label for="date">address</label>
              <textarea class="input-box" name="address" placeholder="Enter your address (Optional)"></textarea>
            </div>
            <input type="hidden" name="pid" value="<?=hashed($prp->id) ?>">
            <input type="hidden" name="ru" value="<?=hashed(current_url()) ?>">
            <button type="submit" class="w-100 text-center btn-black">Confirm</button>
          <?=form_close() ?>
        </div>
      </div>
    </div>
  </section>
