<?php
if ($this->uri->segment(1) == 'location') {
  $formURL = base_url('search/location.html');
  if ($page == 'location' && !empty($this->input->get('location'))) {
    $locationData = @$this->crud->getDataSingle('locations', $this->input->get('location'), 'uri', null);
    $pageHeading = 'Properties in '.@$locationData->title;
  }else {
    $pageHeading = 'All Properties by Locations';
  }
} else {
  $formURL = base_url('search.html');
  $pageHeading = 'All Properties';
}
$location = !empty($this->input->get('location')) ? $this->input->get('location'): null;
$property_type = !empty($this->input->get('property_type')) ? $this->input->get('property_type'): null;
$bedrooms = !empty($this->input->get('bedrooms')) ? $this->input->get('bedrooms'): null;
$bathrooms = !empty($this->input->get('bathrooms')) ? $this->input->get('bathrooms'): null;
$minbudget = !empty($this->input->get('minbudget')) ? $this->input->get('minbudget'): null;
$maxbudget = !empty($this->input->get('maxbudget')) ? $this->input->get('maxbudget'): null;
?>
<section class="listing-pg">
  <div class="custom-container">
    <!-- ajax filter -->
    <?=form_open($formURL,['class'=>'advance-filter ptb-32']) ?>
      <div class="grids-6 filter-dp align-end gap-8">
        <div class="div-filter">
          <label for="PropertyType">Property Type</label>
          <select class="form-select-input" id="property-type" name="property_type" aria-label="Default select property type">
            <option value="">Choose type of property</option>
            <?php foreach ($this->crud->getDataAll('property_list', 'title', 'asc') as $property_list): ?>
              <option value="<?=$property_list->title ?>" <?=$property_type==$property_list->title ?'selected':null ?>><?=$property_list->title ?></option>
            <?php endforeach; ?>
          </select>
        </div>
        <!-- 1 -->
        <div class="div-filter">
          <label for="Bedrooms">Bedrooms</label>
          <select class="form-select-input" id="bedrooms" name="bedrooms" aria-label="Default select bedrooms">
            <option value="">Choose bathrooms</option>
            <?php for($i=1; $i <= 20; $i++){ ?>
              <option value="<?=$i ?>" <?=($bedrooms == $i)?'selected':null ?>><?=$i ?></option>
            <?php } ?>
          </select>
        </div>
        <!-- 1 -->
          <div class="div-filter">
          <label for="Bathroom">Bathrooms</label>
          <select class="form-select-input" id="bathrooms" name="bathrooms" aria-label="Default select bathrooms">
            <option value="">Choose bedrooms</option>
            <?php for($i=1; $i <= 20; $i++){ ?>
              <option value="<?=$i ?>" <?=($bathrooms == $i)?'selected':null ?>><?=$i ?></option>
            <?php } ?>
          </select>
        </div>
        <!-- 1 -->
        <div class="div-filter">
          <label for="Location">Locations</label>
          <select class="form-select-input" id="location" name="location" aria-label="Default select locations">
            <option value="">Choose location</option>
            <?php foreach ($this->crud->getDataAll('locations', 'title', 'asc') as $location): ?>
              <option value="<?=$location->uri ?>" <?=$location==$location->uri ?'selected':null ?>><?=$location->title ?></option>
            <?php endforeach; ?>
          </select>
        </div>
        <!-- 1 -->
        <div class="div-filter w-100">
          <label>Price Range</label>
          <div class="range-slider">
            <input type="text" class="js-range-slider" value="" />
          </div>
          <div class="extra-controls form-inline" style="visibility: hidden;height:0;">
            <div class="form-group">
              <input type="text" name="minbudget" class="js-input-from form-control" value="0" />
              <input type="text" name="maxbudget" class="js-input-to form-control" value="2000000" />
            </div>
          </div>
        </div>
        <!-- 1 -->
        <div class="div-filter">
          <label for="submit-form"> </label>
          <button class="comm-btn nowclick" type="submit" name="submit-form">Apply</button>
          <?php if ($this->uri->segment(1) == 'buy'): ?>
            <input type="hidden" name="buyrent" value="buy">
          <?php endif; ?>
          <?php if ($this->uri->segment(1) == 'rent'): ?>
            <input type="hidden" name="buyrent" value="rent">
          <?php endif; ?>
        </div>
        <!-- 1 -->
      </div>
    <?=form_close() ?>
    <!-- ajax filter -->
  </div>
</section>
<section class="listing-pagi bc-gray">
  <div class="custom-container">
    <!-- div show list more -->
    <div class="dflex gap-30 wrap-count-list">
      <div class="width-720">
        <div class="flex-js-b heading-v1 flex-acenter">
          <h4 class="fs-24">
            <?=$pageHeading ?>
          </h4>
        </div>
        <div class="grids-2 more-gap">
          <!-- 1 -->
          <?php
            $status = $this->uri->segment(1);
            switch ($status) {
              case 'buy':
                $page = 'buy';
                break;
              case 'rent':
                $page = 'rent';
                break;
              default:
                $page = null;
                break;
            }
           ?>
          <?php $lpi = 1; foreach ($propertyList as $lp): ?>
            <!-- listing items <?=$lpi ?> start -->
            <div class="pro-list pos-relative">
              <?php if ($lp->featured_properties == 'yes'): ?>
                <span class="badges set-abs">featured</span>
              <?php endif; ?>
              <?php if (!empty($lp->cover_photo)): ?>
                <img class="img-responsive box-img b-radius-4" src="<?=base_url($lp->cover_photo)?>" width="100%"  alt="<?=$lp->title ?>">
              <?php else: ?>
                <img class="img-responsive box-img b-radius-4" src="<?=base_url('assets/')?>img/locations.png" width="100%"  alt="<?=$lp->title ?>">
              <?php endif; ?>
              <div class="pro-list-info flex-col">
                <p class="typeof-pop color-gray"> for <?=$lp->for_status ?> </p>
                <div class="address-pop">
                  <h2 class="fs-18 "><?=@$lp->title ?></h2>
                  <p class="address-info color-gray"><?=@$this->crud->getDataSingle('locations', $lp->location, 'uri', null)->title ?></p>
                </div>
                <ul class="flex-acenter list-ami">
                  <?php if (!empty($lp->bedrooms)): ?>
                    <li class="flex-acenter ami-list">
                      <span class="ami-icons">
                        <img class="img-responsive b-radius-4" src="<?=base_url('assets/')?>icons/icon-bed.svg" width="24"  height="24" alt="Bed list">
                      </span>
                      <span class="ami-data"><?=$lp->bedrooms ?></span>
                    </li>
                  <?php endif; ?>
                  <?php if (!empty($lp->bathrooms)): ?>
                    <li class="flex-acenter ami-list">
                      <span class="ami-icons">
                        <img class="img-responsive" src="<?=base_url('assets/')?>icons/icon-jh.svg" width="24"  height="24" alt="Bed list">
                      </span>
                      <span class="ami-data"><?=$lp->bathrooms ?></span>
                    </li>
                  <?php endif; ?>
                  <?php if (!empty($lp->property_size)): ?>
                  <li class="flex-acenter ami-list">
                    <span class="ami-icons">
                      <img class="img-responsive" src="<?=base_url('assets/')?>icons/icon-area.svg" width="24"  height="24" alt="Bed list">
                    </span>
                    <span class="ami-data"><?=$lp->property_size ?> <?=$lp->property_size_matrix ?> </span>
                  </li>
                  <?php endif; ?>
                </ul>
                <p class="ml-price fs-18-sm">
                  ฿ <?=$this->cart->format_number($lp->price ?? 0) ?>
                </p>
                <div class="flex-col clickbtn text-center">
                  <a  class="w-100 btn-100 btn-outline" href="<?=base_url('property/'.$lp->uri.'.html')?>" targrt="_blank"> See Details</a>
                  <!-- <a  class="w-100 btn-100 btn-bg" href="<?=base_url('property/'.$lp->uri.'.html')?>" targrt="_blank"> Inquire Now</a> -->
                </div>
              </div>
            </div>
            <!-- listing items <?=$lpi ?> end -->
            <?php $lpi++; endforeach; ?>
          <!-- 1 -->
        </div>
        <div class="w-100 d-block">
          <?=$links ?>
        </div>
      </div>
      <div class="flex-1 google-api">
        <iframe title="google map" src="https://www.google.com/maps/embed?pb=!1m18!1m12!1m3!1d3875.902294039341!2d100.57886926896477!3d13.724364868482608!2m3!1f0!2f0!3f0!3m2!1i1024!2i768!4f13.1!3m3!1m2!1s0x30e29fae50dbba77%3A0x58f40cc72a5f8bc8!2s30%20Sukhumvit%2061%2C%20Khwaeng%20Khlong%20Tan%20Nuea%2C%20Watthana%2C%20Krung%20Thep%20Maha%20Nakhon%2010110%2C%20Thailand!5e0!3m2!1sen!2sus!4v1723057856689!5m2!1sen!2sus" width="100%" height="100%" style="border:0;" allowfullscreen="" loading="lazy" referrerpolicy="no-referrer-when-downgrade"></iframe>
      </div>
    </div>
    <!-- div show list more -->
    <div class="Property-lo-post">
      <div class="flex-js-b mb-32 flex-acenter">
        <h4 class="fs-24">Property by Location</h4>
      </div>
      <div class="custom-container">
        <div  class="grids-4 pro-lo-list">
          <?php $loi = 1; foreach ($this->crud->getDataAll('locations', 'title', 'ASC') as $loc): ?>
            <!-- item 1 -->
            <div class="pro-lo-item">
              <!-- <a href="<?=base_url('location/'.$loc->uri.'.html')?>" targrt="_blank"> -->
              <a href="<?=base_url('location.html?location='.$loc->uri)?>">
                <div class="pro-lo-thumbs pos-relative">
                  <?php if (file_exists($loc->img)): ?>
                    <img class="img-responsive" src="<?=base_url($loc->img) ?>" alt="<?=$loc->title ?>" style="width:100%;">
                  <?php else: ?>
                    <img class="img-responsive" src="<?=base_url('upload/default/gallery.svg') ?>" alt="<?=$loc->title ?>" style="width:100%;">
                  <?php endif; ?>
                  <div class="pro-lo-title">
                    <h4 class="fs-20 color-white"><?=$loc->title ?></h4>
                    <p class="count-list color-white"> <span class="count-location"><?=$this->crud->getCount('property', 'location', $loc->uri) ?></span> properties listed</p>
                  </div>
                </div>
              </a>
            </div>
            <!-- item 1 -->
            <?php $loi++; endforeach; ?>
          </div>
        </div>
      </div>
    </div>
  </section>
