<!DOCTYPE html>

<html lang="en">

<head>

  <meta charset="UTF-8">

  <meta name="viewport" content="width=device-width, initial-scale=1.0">

  <meta http-equiv="X-UA-Compatible" content="ie=edge">

  <title>Sign In - Accel</title>

  <link href="<?=base_url('images/favicon.ico')?>" sizes="128x128" rel="shortcut icon" type="image/x-icon" />

  <link href="<?=base_url('images/favicon.ico')?>" sizes="128x128" rel="shortcut icon" />

  <style media="screen">

  * {

    font-family: -apple-system, BlinkMacSystemFont, "San Francisco", Helvetica, Arial, sans-serif;

    font-weight: 300;

    margin: 0;

  }

  html, body {

    height: 100vh;

    width: 100vw;

    margin: 0 0;

    display: flex;

    align-items: flex-start;

    justify-content: flex-start;

    background: #f3f2f2;

  }

  h4 {

    font-size: 24px;

    font-weight: 600;

    color: #000;

    opacity: 0.85;

  }

  label {

    font-size: 12.5px;

    color: #000;

    opacity: 0.8;

    font-weight: 400;

  }

 

  form h4 {

    margin-bottom: 20px;

    color: rgba(0, 0, 0, 0.5);

  }

  form h4 span {

    color: black;

    font-weight: 700;

  }

  form p {

    line-height: 155%;
    margin-bottom: 5px;
    font-size: 14px;
    color: #000;
    opacity: 0.65;
    font-weight: 400;
    margin-bottom: 1.5rem;

  }

  a.discrete {

    color: rgba(0, 0, 0, 0.4);

    font-size: 14px;

    border-bottom: solid 1px rgba(0, 0, 0, 0);

    padding-bottom: 4px;

    margin-left: auto;

    font-weight: 300;

    transition: all 0.3s ease;

    margin-top: 40px;

  }

  a.discrete:hover {

    border-bottom: solid 1px rgba(0, 0, 0, 0.2);

  }

  button {

    display: inline-flex !important;
    gap: 0.2rem;
    align-items: center;
    justify-content: center;
    border-radius: .375rem;
    padding: 0.76rem 1.25rem;
    background-color: var(--primary);
    color: #fff;
    background-color: #7367f0;
    border-color: #7367f0;
    transition: all .135s ease-in-out;
    transform: scale(1.001);
    text-transform: capitalize;
    border: 0;
    cursor: pointer;
    width: 100%;

  }

  button:hover {

    transform: translateY(-3px);

    box-shadow: 0 2px 6px -1px rgba(182, 157, 230, 0.65);

  }

  button:hover:active {

    transform: scale(0.99);

  }

  input {

    font-size: 16px;

    padding: 20px 0px;

    height: 56px;

    border: none;

    border-bottom: solid 1px rgba(0, 0, 0, 0.1);

    background: #fff;

    min-width: 100%;

    box-sizing: border-box;

    transition: all 0.3s linear;

    color: #000;

    font-weight: 400;

    -webkit-appearance: none;

  }

  input:focus {

    border-bottom: solid 1px #b69de6;

    outline: 0;

    box-shadow: 0 2px 6px -8px rgba(182, 157, 230, 0.45);

  }

  .floating-label {

    position: relative;

    margin-bottom: 10px;

  }

  .floating-label label {

    position: absolute;

    top: calc(50% - 7px);

    left: 0;

    opacity: 0;

    transition: all 0.3s ease;

  }

  .floating-label input:not(:-moz-placeholder-shown) {

    padding: 28px 0px 12px 0px;

  }

  .floating-label input:not(:-ms-input-placeholder) {

    padding: 28px 0px 12px 0px;

  }

  .floating-label input:not(:placeholder-shown) {

    padding: 28px 0px 12px 0px;

  }

  .floating-label input:not(:-moz-placeholder-shown) + label {

    transform: translateY(-10px);

    opacity: 0.7;

  }

  .floating-label input:not(:-ms-input-placeholder) + label {

    transform: translateY(-10px);

    opacity: 0.7;

  }

  .floating-label input:not(:placeholder-shown) + label {

    transform: translateY(-10px);

    opacity: 0.7;

  }

  .session {
    margin: auto auto;
    border-radius: .375rem;
    background: #ffffff;
    max-width:375px;
    width:100%;
    padding: 3rem;
    flex: 1 1 auto;
    background-clip: padding-box;
    box-shadow: 0 .1875rem .75rem 0 rgba(47, 43, 61, .14);

  }

 




  </style>

</head>

<body>

  <div class="session container-xxl">

  
    <?=form_open(base_url('login/authenticate.html'),['class'=>'log-in']) ?>

    <h4>We are <span><?=$this->crud->getSetting('websiteName') ?></span></h4>

    <p>Welcome back! Log in to your account  and start the adventure:</p>

    <div class="floating-label">

      <input placeholder="Username" type="text" name="username" id="email" required>

      <label for="email">Username:</label>

    </div>

    <div class="floating-label">

      <input placeholder="Password" type="password" name="password" id="password" required>

      <label for="password">Password:</label>

    </div>

    <button type="submit">Log in</button>

    <?=form_close() ?>

  </div>

  <?php if ($this->session->flashdata('type') && $this->session->flashdata('title') && $this->session->flashdata('msg')) {?>

    <script src="<?=base_url('secure/') ?>vendor/jquery-3.2.1.min.js" ></script>

    <script src="https://unpkg.com/sweetalert/dist/sweetalert.min.js"></script>

    <script>

    $(document).ready(function(){

      swal({

        title: "<?=$this->session->flashdata('title') ?>",

        text: "<?=$this->session->flashdata('msg') ?>",

        icon: "<?=$this->session->flashdata('type') ?>",

        button: false,

        timer: 2500

      });

    });

    </script>

  <?php } ?>	

</body>

</html>